<?php
//获取大小
function code2size($code){
    return \Kuoqi\Helper::code2size($code);
}

/**
 * 公共方法，cache,当第二个参数为''时判定为获取，需要设置这些特殊值的时候使用getCache与setCache函数进行进一步的设置
 * createby kuoqi at 2022/8/16 23:20
 * @param $cname
 * @param string $cval
 * @param string $ctime
 * @param string $cpath
 * @return mixed|null|string
 */
function cache($cname,$cval = '',$ctime = '0',$cpath = '')
{
    return \Kuoqi\Helper::Cache($cname,$cval,$ctime,$cpath);
}

/**
 * 获取缓存
 * createby kuoqi at 2022/8/16 23:24
 * @param $cname
 * @param string $cpath
 * @param bool $isCommon
 * @return mixed|null
 */
function getCache($cname,$cpath = '',$isCommon = false){
    return \Kuoqi\Helper::getCache($cname,$cpath,$isCommon);
}

/**
 * 设置缓存
 * createby kuoqi at 2022/8/16 23:24
 * @param $cname
 * @param string $cval
 * @param string $ctime
 * @param string $cpath
 * @param bool $isCommon
 * @return string
 */
function setCache($cname,$cval = '',$ctime = '0',$cpath = '',$isCommon = false){
    return \Kuoqi\Helper::setCache($cname,$cval,$ctime,$cpath,$isCommon);
}
//获取数据输入的方式
function I($param = '',$default = NULL,$delFunc = NULL,$isOpt = false)
{
    return \Kuoqi\Helper::getParam($param,$default,$delFunc,$isOpt);
}
//尝试获取用户的IP
function ipfClient()
{
    $IPaddress='';
    if(isset($_SERVER)){
        if(isset($_SERVER["HTTP_X_FORWARDED_FOR"])){
            $IPaddress = $_SERVER["HTTP_X_FORWARDED_FOR"];
        }else if(isset($_SERVER["HTTP_CLIENT_IP"])){
            $IPaddress = $_SERVER["HTTP_CLIENT_IP"];
        }else{
            $IPaddress = $_SERVER["REMOTE_ADDR"];
        }
    }else{
        if(getenv("HTTP_X_FORWARDED_FOR")){
            $IPaddress = getenv("HTTP_X_FORWARDED_FOR");
        }else if(getenv("HTTP_CLIENT_IP")) {
            $IPaddress = getenv("HTTP_CLIENT_IP");
        }else{
            $IPaddress = getenv("REMOTE_ADDR");
        }
    }
    return $IPaddress;
}

/**
 * 检测是否wap
 * @return bool|string
 */
function check_wap(){
    if(stristr($_SERVER['HTTP_VIA'],"wap")){
        return true;
    }elseif(strpos(strtoupper(@$_SERVER['HTTP_ACCEPT']),"VND.WAP.WML") > 0){
        return true;
    }elseif(preg_match('/(blackberry|configuration\/cldc|hp |hp-|htc |htc_|htc-|iemobile|kindle|midp|mmp|motorola|mobile|nokia|opera mini|opera |Googlebot-Mobile|YahooSeeker\/M1A1-R2D2|android|iphone|ipod|mobi|palm|palmos|pocket|portalmmm|ppc;|smartphone|sonyericsson|sqh|spv|symbian|treo|up.browser|up.link|vodafone|windows ce|xda |xda_)/i', $_SERVER['HTTP_USER_AGENT'])){
        if(preg_match('/MicroMessenger/',$_SERVER['HTTP_USER_AGENT'])){
            return 'wx';
        }
        return true;
    }else
    {
        return false;
    }
}
//配置信息获取
function config($n,$v = null){
    return \Kuoqi\Helper::config($n,$v);
}
/**
 * 输入dump
 * @param $rs
 */
function dump($rs){
    echo '<pre>';
    echo print_r($rs,true);
    echo '</pre>';
}

function M($isPrefix = '',$asName = false)
{
    return \Kuoqi\Helper::Mysql($isPrefix,$asName);
}
//获取价格的函数
function price_encode($code){
    return sprintf('%.2f',intval($code)/100);
}
//设置价格的函数
function price_decode($code){
    return intval(floatval($code) * 100);
}

function url($route,$query = array(),$isComplex = false){
    return \Kuoqi\Helper::url($route,$query,$isComplex);
}

//转换为密码
function password_encode($str){
    return \Kuoqi\Helper::password_encode($str);
}

function session($sn,$sv = null){
    return \Kuoqi\Helper::session($sn,$sv);
}

//模型
function template($tpid,$tp_agrs = array()){
    return \Kuoqi\Helper::useTemplate($tpid,$tp_agrs);
}
function kong($str = false){
    return $str;
}
//根据时间信息计算时间格式
function format_time($time){
    $time = intval($time);
    if(!$time){
        return '0秒';
    }
    if($time / 60>1){
        $stream = $time % 60 ."秒";
        $time = intval($time / 60);
        $stream = $time.'分'.$stream;
    }else{
        $stream = $time.'秒';
    }
    return $stream;
}

// input-> modbus rtu string
// output -> 2bytes string, in correct modbus order
//a NUL-padded string
//A SPACE-padded string
//h Hex string, low nibble first
//H Hex string, high nibble first
//c signed char
//C unsigned char
//s signed short (always 16 bit, machine byte order)
//S unsigned short (always 16 bit, machine byte order)
//n unsigned short (always 16 bit, big endian byte order)
//v unsigned short (always 16 bit, little endian byte order)
//i signed integer (machine dependent size and byte order)
//I unsigned integer (machine dependent size and byte order)
//l signed long (always 32 bit, machine byte order)
//L unsigned long (always 32 bit, machine byte order)
//N unsigned long (always 32 bit, big endian byte order)
//V unsigned long (always 32 bit, little endian byte order)
//q signed long long (always 64 bit, machine byte order)
//Q unsigned long long (always 64 bit, machine byte order)
//J unsigned long long (always 64 bit, big endian byte order)
//P unsigned long long (always 64 bit, little endian byte order)
//f float (machine dependent size and representation)
//d double (machine dependent size and representation)
//x NUL byte
//X Back up one byte
//Z NUL-padded string (new in PHP 5.5)
//@ NUL-fill to absolute position
function crc16($string, $length = 0)
{
    $auchCRCHi = array(
        0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81,
        0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
        0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01,
        0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41,
        0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81,
        0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
        0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01,
        0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
        0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81,
        0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
        0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01,
        0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
        0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81,
        0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
        0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01,
        0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
        0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81,
        0x40
    );
    $auchCRCLo = array(
        0x00, 0xC0, 0xC1, 0x01, 0xC3, 0x03, 0x02, 0xC2, 0xC6, 0x06, 0x07, 0xC7, 0x05, 0xC5, 0xC4,
        0x04, 0xCC, 0x0C, 0x0D, 0xCD, 0x0F, 0xCF, 0xCE, 0x0E, 0x0A, 0xCA, 0xCB, 0x0B, 0xC9, 0x09,
        0x08, 0xC8, 0xD8, 0x18, 0x19, 0xD9, 0x1B, 0xDB, 0xDA, 0x1A, 0x1E, 0xDE, 0xDF, 0x1F, 0xDD,
        0x1D, 0x1C, 0xDC, 0x14, 0xD4, 0xD5, 0x15, 0xD7, 0x17, 0x16, 0xD6, 0xD2, 0x12, 0x13, 0xD3,
        0x11, 0xD1, 0xD0, 0x10, 0xF0, 0x30, 0x31, 0xF1, 0x33, 0xF3, 0xF2, 0x32, 0x36, 0xF6, 0xF7,
        0x37, 0xF5, 0x35, 0x34, 0xF4, 0x3C, 0xFC, 0xFD, 0x3D, 0xFF, 0x3F, 0x3E, 0xFE, 0xFA, 0x3A,
        0x3B, 0xFB, 0x39, 0xF9, 0xF8, 0x38, 0x28, 0xE8, 0xE9, 0x29, 0xEB, 0x2B, 0x2A, 0xEA, 0xEE,
        0x2E, 0x2F, 0xEF, 0x2D, 0xED, 0xEC, 0x2C, 0xE4, 0x24, 0x25, 0xE5, 0x27, 0xE7, 0xE6, 0x26,
        0x22, 0xE2, 0xE3, 0x23, 0xE1, 0x21, 0x20, 0xE0, 0xA0, 0x60, 0x61, 0xA1, 0x63, 0xA3, 0xA2,
        0x62, 0x66, 0xA6, 0xA7, 0x67, 0xA5, 0x65, 0x64, 0xA4, 0x6C, 0xAC, 0xAD, 0x6D, 0xAF, 0x6F,
        0x6E, 0xAE, 0xAA, 0x6A, 0x6B, 0xAB, 0x69, 0xA9, 0xA8, 0x68, 0x78, 0xB8, 0xB9, 0x79, 0xBB,
        0x7B, 0x7A, 0xBA, 0xBE, 0x7E, 0x7F, 0xBF, 0x7D, 0xBD, 0xBC, 0x7C, 0xB4, 0x74, 0x75, 0xB5,
        0x77, 0xB7, 0xB6, 0x76, 0x72, 0xB2, 0xB3, 0x73, 0xB1, 0x71, 0x70, 0xB0, 0x50, 0x90, 0x91,
        0x51, 0x93, 0x53, 0x52, 0x92, 0x96, 0x56, 0x57, 0x97, 0x55, 0x95, 0x94, 0x54, 0x9C, 0x5C,
        0x5D, 0x9D, 0x5F, 0x9F, 0x9E, 0x5E, 0x5A, 0x9A, 0x9B, 0x5B, 0x99, 0x59, 0x58, 0x98, 0x88,
        0x48, 0x49, 0x89, 0x4B, 0x8B, 0x8A, 0x4A, 0x4E, 0x8E, 0x8F, 0x4F, 0x8D, 0x4D, 0x4C, 0x8C,
        0x44, 0x84, 0x85, 0x45, 0x87, 0x47, 0x46, 0x86, 0x82, 0x42, 0x43, 0x83, 0x41, 0x81, 0x80,
        0x40
    );
    $length        = ($length <= 0 ? strlen($string) : $length);
    $uchCRCHi    = 0xFF;
    $uchCRCLo    = 0xFF;
    $uIndex        = 0;
    for ($i = 0; $i < $length; $i++) {
        $uIndex        = $uchCRCLo ^ ord(substr($string, $i, 1));
        $uchCRCLo    = $uchCRCHi ^ $auchCRCHi[$uIndex];
        $uchCRCHi    = $auchCRCLo[$uIndex];
    }
    return (chr($uchCRCLo) . chr($uchCRCHi));
}

function modbus_crc($ipt,$isformat = true){
    $s = pack('H*',$ipt);
    $t = crc16($s);
    if($isformat){
        $opt = strtoupper(unpack("H*", $s.$t)[1]);
    }else{
        $opt = strtoupper(unpack("H*",$t)[1]);
    }
    return $opt;
}

//16进制数字的字符串转2进制的数字的字符串，会自动补位

function tel($tel){
    $tel = preg_replace('/^(\d{3})(\d+)(\d{4})$/','$1****$3',$tel);
    return $tel;
}

//二进制字符串转换为数字
function bin2int($code){
    return $code;
}

//16进制字符串转换为整数,默认有符号
function hex2int($code,$is_symbol = true){
    $stream = base_convert('F'.$code,16,2);
    $stream = substr($stream,4);
    if(substr($stream,0,1)==0){
        //正数的补码是它本省
        $int = intval(base_convert($stream,2,10));
    }else{
        $nstr = "0";
        for ($i=0;$i<strlen($stream);$i++){
            if($i==0){
                $nstr = "0";
            }else{
                $nstr .= substr($stream,$i,1)?0:1;
            }
        }
        //$nstr+1;
        $int = -(base_convert($nstr,2,10) + 1);
    }
    return $int;
}

function num2letter($num){
    return \Kuoqi\Helper::num2letter($num);
}

//判断对错的函数
function determine($code,$keySure,$keyErr){
    return \Kuoqi\Helper::determine($code,$keySure,$keyErr);
}

/**
 * untag 2024/4/30 不加标签
 * @param $content
 * @return string
 */
function untag($content){
    return strip_tags($content);
}

//获取模块的名称
function getModelname(){
    return \Kuoqi::$app->getModeler();
}

/**
 * 图片缩略图
 * imgthumb 2024-10-06
 * @param $link
 * @param $w
 * @param $h
 * @param $code
 * @return mixed
 */
function imgthumb($link,$w,$h,$code){
    return \Kuoqi\Helper::imgthumb($link,$w,$h,$code);
}

/**
 * 展示技术签名的内容
 */
if(!function_exists("support_signer")){
    function support_signer(){
        return sprintf('<a target="_blank" href="%s" class="label label-small label-tips">%s</a>'
            ,Config("support_link")
            ,Config("support_text")
        );
    }
}
