<?php

namespace Kuoqi;
use Kuoqi\Httpd\Socket;

/**
 * HTTP与HTTPS的核心服务模块，这里同时也有一个专门的核心的用户名密码，进行一个最高权限的管理
 * 默认这个是一个最高级别的用户的管理
 * Class Httpd
 * @package Kuoqi
 */
class Httpd extends \Kuoqi\KuoqiException {
    protected $_addr = '0.0.0.0';//监听的地址信息
    protected $_port = '8080';//监听的端口信息
    protected $_app_root = '/';//当前应用文件的根目录
    protected $_socket = null;//socket的核心对象
    public function setAddr($addr){ $this->_addr = $addr;}
    public function setPort($port){ $this->_port = $port;}
    public function setApproot($app_root){ $this->app_root = $app_root;}
    //创建服务
    protected function createServer(){
        $this->_socket = new Socket($this->_addr,$this->_port);
        $this->_socket->bindServer($this);
    }
    //运行服务
    protected function runningServer(){
        //执行一个永久的程序，并且会一直存在的那种
        while(true){
            $this->_socket->listen();
        }
    }

    //执行一个开始
    public function start(){
        $this->createServer();//创建服务
        $this->runningServer();//运行服务
        \Kuoqi::log("开始执行");
    }

}

