<?php
namespace Kuoqi;
/**
 * Class Phpr 一个常规的php软件包
 * @package Kuoqi
 */
class Phar extends \Kuoqi\KuoqiException {
    public $server = null;//当前的php对象
    public $_file_driver = null;//文件驱动对象
    protected $_path_driver = null;//路径对象信息
    public function __construct($fname, $flags = null, $alias = null)
    {
        $this->_file_driver = new \Kuoqi\FileDriver($fname);
        $this->_file_driver->checkPath();
        $this->_file_driver->delete();
        $this->server = new \Phar($this->_file_driver->getFullfile(true), $flags, $alias);
        $this->_path_driver = new PathDriver("{@APP}");
    }

    //跳转到一个虚拟的文件夹
    public function cd($path){
        $this->_path_driver->cd($path);
    }
    //获取当前目录
    public function getDir($fname = ''){
        return $this->_path_driver->getDir($fname);

    }
    //根据字符串写入文件
    public function putByString($fname,$fstream){
        //$this->server->addFile();
        $this->server->addFromString($this->getDir($fname),$fstream);
    }
    //根据文件名写入
    public function putFile($fname,$iptfname){
        $this->server->addFile(\Kuoqi\Route::str2rootpath($iptfname),$this->_path_driver->getReal($fname,false));
    }
    //创建一个空的文件夹
    public function putPath($pathname){
        $this->server->addEmptyDir($this->_path_driver->getReal($pathname,false));
    }

    /**
     * 直接写入文件或者文件夹,不能包含非文件字符串
     * @param $fname
     * @param $locfname
     * @return bool
     * @throws Error
     */
    public function put($locfname){
        $locfname = \Kuoqi\Route::str2rootpath($locfname);
        if(is_file($locfname)){
            //判定为文件
            $this->putFile($locfname,$locfname);
        }else if(is_dir($locfname)){
            $dirDriver = new \Kuoqi\PathDriver($locfname);
            //循环当前的文件夹信息
            $dirDriver->eachFiles(function($filename){
                $this->put($filename);
            });
        }else{
            throw new Error("判定为异常文件:".$locfname);
        }
    }
}