<?php
namespace Kuoqi;
/**
 * 多进程管理模块
 * Class Package
 * @package Kuoqi
 */
//守护进程使用主备模式进行守护，
//守护进程下可开很多很多的业务进程，业务进程使用PHP脚本的方式进行，不加渲染KuoqiPHP的色彩
class Process extends \Kuoqi\KuoqiException {
    protected $pid = 'process.pid';//链接信息
    protected $pid_path = '{@APP}/runtime/process/';//这个是pid的路径
    protected $fp = null;//文件信息
    protected $config = array();//这里是配置文件的相关信息，这里可以配置二级文件信息
    //每一个进程都有一个守护文件，根据守护文件判定该进程是否存活，守护进程执行start则为守护进程启动，收回进程执行end则关闭当前守护进程
    public function __construct()
    {
        //一旦重置脚本则不需要额外新增任何的进程信息
        $this->configRead();
        //这个是阅读到文件结尾的地方了
        //然后将配置的相关信息
        if(!(isset($this->config['start_time']))){ $this->config['start_time'] = time();}
        if(!(isset($this->config['name']))){ $this->config['name'] = '幻冰进程管理';}

        //去除临时进程的相关信息
        if(!(isset($this->config['process'])&&is_array($this->config['process']))){
            $this->config['process'] = array();
        }
        //初始化进程的时候，不做任何的进程相关的处理
        //$this->configSync();
    }

    //读取配置文件
    public function configRead(){
        clearstatcache();
        $pid = $this->pid_path.$this->pid;
        $driver = new \Kuoqi\FileDriver($pid);
        $driver->safe_code = "";
        $this->config = json_decode($driver->getContent(\Kuoqi\Helper::jsonencode($this->config)),true);
        return $this->config;
    }
//    public function configRead(){
//        clearstatcache();
//        //读取配置
//        $config = array();
//        $config_c = '';
//        //这里创建进程的PID守护文件信息
//        //文件是否存在，不存在则尝试自动创建
//        $pid = \Kuoqi\Route::str2rootpath($this->pid_path.$this->pid);
//        if(!(@is_dir(dirname($pid))||@mkdir(dirname($pid),0777,true))){
//            throw new Error(sprintf("开始失败，请检查文件夹%s权限",$this->pid_path));
//        }
//        $this->fp = @fopen($pid,'a+');
//        if(!$this->fp){
//            throw new Error("开始失败，文件打开失败");
//        }
//        while (!feof($this->fp)){
//            //这个是未到文件结尾的时候，这个需要做相关处理
//            $line = fgets($this->fp);
//            if(preg_match('/\[(\w+)\]/',$line,$mlis)){
//                //这个是将配置的参数名配置上去的方式
//                $config_c = $mlis[1];
//            }else{
//                $tmp = stripos($line,'=');
//                if($tmp>0&&$config_c){
//                    $config[$config_c][substr($line,0,$tmp)] = str_replace("\n","",substr($line,$tmp+1));
//                }
//            }
//        }
//        $this->fp&&@fclose($this->fp);
//        return $this->config = $config;
//    }

    /**
     * 将config同步到配置文件中
     */
    public function configSync(){
        $pid = $this->pid_path.$this->pid;
        $driver = new \Kuoqi\FileDriver($pid);
        $driver->safe_code = "";
        $driver->setContent(\Kuoqi\Helper::jsonencode($this->config));
        $driver->save();
    }

    /**
     * 这是原始的PID方式，暂时不需要使用
     * @throws Error
     */
//    public function configSyncBak(){
//        $pid = \Kuoqi\Route::str2rootpath($this->pid_path.$this->pid);
//        if(!(@is_dir(dirname($pid))||@mkdir(dirname($pid),0777,true))){
//            throw new Error(sprintf("开始失败，请检查文件夹%s权限",$this->pid_path));
//        }
//        $this->fp = @fopen($pid,'w');
//        if(!$this->fp){
//            throw new Error("开始失败，文件打开失败");
//        }
//        foreach ($this->config as $k=>$v){
//            if(is_array($v)){
//                fwrite($this->fp,sprintf("[%s]\n",$k));
//                foreach ($v as $cn=>$cv){
//                    fwrite($this->fp,sprintf("%s=%s\n",$cn,$cv));
//                }
//            }
//        }
//        $this->fp&&@fclose($this->fp);
//    }
    //执行写入一个配置参数
    public function configWrite($n,$v,$c){
        $this->config[$c][$n] = $v;
        $this->configSync();
    }

    //开启守护进程
    public function start(){}
    //执行关闭守护进程
    public function end(){}
}