<?php
namespace Kuoqi;
/**
 * 关于算法的基础配置,当然这里的算法是，自定义的算法
 * Class Secret
 * @package Kuoqi
 */
class Secret{

    static public function base64_encode($stream){
        $lib = $code = Config::get("BASE64_CODEINDEX");
        $nstr = '';
        for($i=0;$i<strlen($stream);$i++){
            $nstr .= str_pad(base_convert (ord($stream[$i]),10,2),8,'0',STR_PAD_LEFT);
        }
        //将字符串进行一个切割
        //将数据进行4个4个的组合
        $ostr = '';
        //根据$nstr判断需要补充多少个字符
        $extlen = strlen($nstr) % 6;//需要额外支援的多少
        if($extlen>0){
            $nstr = sprintf('%s%s',$nstr,str_pad('',6-$extlen,'0'));
        }

        foreach (str_split($nstr,6) as $it){
            //将字符拿出来进行解析
            //将二进制转换为10进制
            $code = base_convert($it,2,10);
            $ostr.= $lib[$code];
        }
        if($extlen){
            //$ostr = sprintf('%s%s',$ostr,str_pad('',$extlen / 2,'='));
        }
        return $ostr;
    }
    static public function base64_decode($stream){
        $lib = Config::get("BASE64_CODEINDEX");
        $nlib = array_flip($lib);
        //查看末位有多少个等号
        $ext = strstr($stream,'=');
        $stream = str_replace($ext,"",$stream);
        //将字母获取为代码
        $nstr = '';
        for($i=0;$i<strlen($stream);$i++){
            //$num = base_convert($ncode[$stream[$i]],10,2);//将数字转换为二进制
            //var_dump(base_convert($nlib[$stream[$i]],10,2));
            $nstr .= str_pad(base_convert($nlib[$stream[$i]],10,2),6,'0',STR_PAD_LEFT);
            //var_dump($num);
        }
        //进行一个数据整合
        $ostr = '';
        foreach (str_split($nstr,8) as $it){
            //将ascii转换为字符
            if(strlen($it)==8){
                $ostr .= chr(base_convert($it,2,10));
            }
        }
        return $ostr;
    }

    /**
     * 数据传输通用编码
     * @param $stream
     * @param int $code
     * @return string
     */
    static public function datapass_encode($stream,$code=129){
        if(!is_scalar($stream)){
            \Kuoqi::log("只允许发送标量数据");
        }
        $first_byte = chr($code);
        $len = strlen($stream);
        if($len<=125)
        {
            $second_byte = chr($len);
            //return $first_byte.chr($len).$stream;
        }else if($len<=65535){
            $second_byte = chr(126) . pack('n' , $len);
            //return $first_byte.chr(126).pack("n", $len).$stream;
        }else{
            $second_byte = chr(127) . pack('xxxN' , $len);
            //var_dump($second_byte);exit();
            //$second_byte = chr(127) . pack('xxxN' , $len);
            //return $first_byte.chr(127).pack("J", $len).$stream;
        }
        $encoded_data = $first_byte . $second_byte . $stream;
        return $encoded_data;
    }

    /**
     * 数据传输通用解码，成功返回固定格式，失败返回false
     * @param $stream
     * @param int $code
     * @return array|bool
     */
    static public function datapass_decode($stream,$code = 129){
        $result = array(
            'iden'=>0,
            'len'=>0,
            'stream'=>''
        );
        $result['iden'] = ord(substr($stream,0,1));
        if($code!=$result['iden']){
            return false;
        }
        $code2 = ord(substr($stream,1,1));
        if($code2<=125){
            $result['len'] = $code2;
            $result['stream'] = substr($stream,2,$code2);
        }else if($code2==126){
            $pack = unpack('n',substr($stream,2,2));
            if($pack){
                $result['len'] = $pack[1];
            }else{
                return false;
            }
            $result['stream'] = substr($stream,4);
        }else if($code2==127){
            $pack = unpack('N',substr($stream,5,4));
            if($pack){
                $result['len'] = $pack[1];
            }else{
                return false;
            }
            $result['stream'] = substr($stream,9);
        }else{
            return false;
        }
        return $result;
    }

}