<?php
namespace Kuoqi;
/**
 * Class Token 关于自定义一个token实现的基本操作
 * @package Kuoqi
 */
class Token{
    /**
     * 创建token，返回md5字段
     * @param $data
     * @param int $timelen
     * @return string
     */
	static public function create($data,$timelen = 86400){
		$stream = serialize($data);
		$stream = Openssl::encode($stream);
		$tkname = md5($stream);
		\Kuoqi\Cache::setCache($tkname,$stream,intval($timelen),'/Token',true);
		return $tkname;
	}

    /**
     * 根据token读取并获得信息
     * @param $tkname
     * @return mixed
     */
	static public function read($tkname){
		$stream = \Kuoqi\Cache::getCache($tkname,'/Token',true);
		$stream = Openssl::decode($stream);
		return unserialize($stream);
	}

    /**
     * 重新写入token数据值
     * @param $tkname
     * @param $newdata
     * @param int $newtimelen
     * @return mixed
     */
    static public function write($tkname,$newdata,$newtimelen = 86400){
        $stream = serialize($newdata);
        $stream = Openssl::encode($stream);
        \Kuoqi\Cache::setCache($tkname,$stream,intval($newtimelen),'/Token',true);
        return $tkname;
    }

    /**
     * token机制的摧毁
     * @param $tkname
     * @return bool
     */
	static public function destroy($tkname){
		return \Kuoqi\Cache::delCache($tkname,'/Token',true);	
	}
}
