<?php
namespace Kuoqi;
/**
 * Class FileDriver 使用同意的文件信息
 * @package Kuoqi
 */
class Url extends KuoqiException {
    //获取系统的url的信息的部分
    static public function stdSystem(){
        $handle = new self();
        $handle->setLink($_SERVER['REQUEST_URI']);
        return $handle;
    }

    protected $_link = '';//输入的基础的链接信息,缓存
    protected $scheme = '';//链接协议类型
    protected $host = '';//链接主机地址
    protected $inlet = '';//入口信息，如果是非重定向为非重定向的入口信息，如果是重定向则为隐藏入口的方式
    protected $path = '';//链接路由信息
    protected $query = '';//链接参数信息
    protected $fragment = '';//链接其他信息
    public $route = '';// 路由模块的相关信息
    protected $_path_arr = array();//path的数组相关参数
    protected $_query_arr = array();//query的数组相关参数
    protected $_dns_params = array();//DNS的参数相关信息
    protected $route_arr = array();//路由的列表信息，由以上参数自动适配的那种
    public function __construct($uri = '',$query = array(),$host = '',$scheme = '',$fragment = '')
    {
        $query && ($this->query=$query);
        $host && ($this->host=$host);
        if(!$this->host){
            $this->host = isset($_SERVER['HTTP_HOST'])?$_SERVER['HTTP_HOST']:'localhost:80';
        }
        if($scheme){
            $this->scheme = $scheme;
        }else{
            $this->scheme = \Kuoqi\Params::$PROTOCOL;
        }
        $fragment && ($this->fragment=$fragment);
        if($uri){
            //对不起，我不支持不同的入口切换，请谅解！！

            $this->path = str_replace(Params::$INDEX,'',$uri);
            $routearr = parse_url($this->path);
            if(isset($routearr['path'])){
                $this->path = $routearr['path'];
            }
            if(isset($routearr['query'])){
                $_query = $routearr['query'];
                $_query = \Kuoqi\Route::query2arr($_query);
                if(!is_array($this->query)){
                    $this->query = array();
                }
                $this->query = array_merge($this->query,$_query);
            }
        }
    }


    /**
     * 设置链接的基础信息
     * @param $link
     * @return bool
     */
    public function setLink($link){
        $this->_link = $link;
        $arr = parse_url($this->_link);
        if(isset($arr['scheme']))
        {
            $this->scheme = $arr['scheme'];
        }
        if(isset($arr['host'])){ $this->host = $arr['host'];}
        if(isset($arr['path'])){
            $this->path = str_replace(Params::$INDEX,'',$arr['path']);
        }
        if(isset($arr['query'])){ $this->query =$arr['query'];}
        if(isset($arr['fragment'])){ $this->fragment = $arr['fragment'];}
        return true;
    }

    //解析为路由的部分信息
    final function analysis(){
        $this->route = new App\Route();
        $this->route->setRoute(str_replace('/','\\',$this->path));//设置路由的相关信息
        $this->route->addRoutes(\Kuoqi\Route::query2arr($this->query));
    }

    //简单的获取路由信息
    public function getRoute(){
        $route = new \Kuoqi\Route($this->path,$this->query);
        return $route;
    }
    //将当前的信息转换为可输出的那种数据来
    //转换为内部专用链接信息
    public function tolink($isComplex = false)
    {
        $this->analysis();
        //这里封装完整的url的信息进行一个整理
        //todo--这里可以整理系统是否使用驼峰写法还是小写的写法
        if($this->route->dnsdeep==0){
            $path = sprintf('/%s/%s/%s'
                ,\Kuoqi\Route::hump2code($this->route->m)
                ,\Kuoqi\Route::hump2code($this->route->c)
                ,\Kuoqi\Route::hump2code($this->route->a)
            );
        }elseif($this->route->dnsdeep==1){
            $path = sprintf('/%s/%s'
                ,\Kuoqi\Route::hump2code($this->route->c)
                ,\Kuoqi\Route::hump2code($this->route->a)
            );
        }elseif($this->route->dnsdeep==2){
            $path = sprintf('/%s'
                ,\Kuoqi\Route::hump2code($this->route->a)
            );
        }else{
            $path = "/";
        }
        //多余的参数进行一个数据的整合
        $query = \Kuoqi\Route::arr2query($this->route->extra);
        $url = $path . ($query ? "?". ($query) : (""));
        //判定如果使用的模式为默认模式
        if(Config::get('INFO_MODE')==0){
            $url = Params::$INDEX . $url;
        }
        if($isComplex){
            if(strlen($isComplex)&&($isComplex!==true)){
                throw new Error("情况等待开发");
            }else{
                //这个是使用当前域名的相关信息
                $url = $this->scheme.'://'.$this->host . $url;
            }
        }
        return $url;
    }

    //增加菜单信息
    public function addQuery($params){
        $stream = '';
        foreach ($params as $k=>$v){
            $stream .= $stream?("&{$k}={$v}"):("{$k}={$v}");
        }
        if($this->query){
            $this->query .= '&'.$stream;
        }else{
            $this->query  = $stream;
        }
    }

}