<?php
namespace Kuoqi\Cli;

/**
 * Class Downfile
 * @package Kuoqi\Cli
 */
class Downfile extends Behavior {

    protected $document = array(
        "[downfile]",
        "文件下载，后续更近一个参数，这个参数为文件路径"
        );
    protected $section = '1024000';
    protected $i = "";
    protected $o = "";
    /**
     * createby kuoqi at 2022/11/11 23:21 初始化start的方法
     * //php kuoqi.php compress js -i kuoqi-php.v1.00.03/application/test.js -o kuoqi-php.v1.00.03/application/test.min.js
     */
    public function start(){
        $this->i = $this->params['i'];
        $this->o = $this->params['o'];
        $length = 0;//待下载文件的长度
        $hadlen = 0;//已经拥有的字符串长度
        if(is_file($this->o)){
            $hadlen = filesize($this->o);
        }
        $ch = curl_init($this->i);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);//启用是否返回的方式
        curl_setopt($ch, CURLOPT_HEADER, true);
        curl_setopt($ch, CURLOPT_NOBODY,true);
        //curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $result = curl_exec($ch);
        $list = explode("\r\n",$result);
        curl_close($ch);
        //然后进行最后一个出栈
        $islive = 0;//是否实时流的方式进行数据获取
        foreach ($list  as $v){
            if(preg_match('/^Content\-Length\:\s(\d+)/',$v,$match)){
                $length = $match[1];
            }
            if(preg_match('/^Connection\:\skeep\-alive/',$v,$match)){
                //这是采用实时流的方式获取文件下载
                $islive = 1;//是否实时流的方式进行数据获取
            }
        }
        if($islive){
            //通过实时流的方式获取数据内容
            return $this->downloadByskeepalive();
        }else{
            $fp = fopen($this->o,'a');//a,w
        }
        if(!$length){
            return \Kuoqi::warn("获取不到文件，请核对后再试");
        }
        //获取文件长度完成，尝试以片段的方式获取文件
        $ch = curl_init($this->i);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);//启用是否返回的方式
        while ($hadlen < $length){
            curl_setopt($ch,CURLOPT_HTTPHEADER,array(
                sprintf('Range: bytes=%s-%s',$hadlen,$hadlen + $this->section)
            ));
            $result = curl_exec($ch);
            fwrite($fp,$result);
            $hadlen+=strlen($result);
            echo "\033[1A";
            \Kuoqi::warn(sprintf("-->%.0f",$hadlen / $length * 100),false);
        }
        curl_close($ch);
        \Kuoqi::warn(sprintf("下载完成：%s",$this->o));
    }
    //根据实时流的数据信息方式下载文件
    public function downloadByskeepalive(){
        \Kuoqi::warn("尝试下载数据流式文件");
        $ch = curl_init($this->i);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,false);//启用是否返回的方式
        curl_setopt($ch,CURLOPT_BUFFERSIZE,100);//启用是否返回的方式
        curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,5);//设置过期的时间长度
        curl_setopt($ch,CURLOPT_TIMEOUT,10);// 设置cURL允许执行的最长秒数。
        //curl_setopt($ch,CURLOPT_RESUME_FROM,1024);//设置过期的时间长度
        $fp = fopen($this->o,'a');//a,w
        $result = curl_exec($ch);
        var_dump($result);exit();
        fwrite($fp,$result);
        \Kuoqi::warn(sprintf("下载完成：%s",$this->o));
        return;
    }
}