<?php
namespace Kuoqi\Cli;

use Kuoqi\Cli\Compress\Compressjs;
use Kuoqi\Error;

/**
 * 内置站点启动
 * Class Httpd
 * @package Kuoqi\Cli
 */
class Httpd extends Behavior {
    protected $document = array(
        "[httpd]启动内置站点",
        "[httpd start]启动内置站点",
    );
    /**
     * createby kuoqi at 2022/11/11 23:21 初始化start的方法
     * //php kuoqi.php compress js -i kuoqi-php.v1.00.03/application/test.js -o kuoqi-php.v1.00.03/application/test.min.js
     */
    public function start(){
        if($this->command=='start'){
            //启动服务的命令信息
            $this->doStart();
        }elseif($this->command=='help'){
            $this->help();//展示帮助方法
        }else{
            //启动服务的指令信息
            $this->doStart();
        }
    }

    //执行启动命令
    public function doStart(){
        \Kuoqi::$app->say("try server httpd");
        $http = new \Kuoqi\Worker\Httpd();
        //开始执行
        if($http->start()){
            \Kuoqi::$app->say("server start init");
            while (true){
                $http->run();
            }
        }else{
            throw new Error($http->getError());
        }
    }
}