<?php
namespace Kuoqi\Cli;

use Kuoqi\Cli\Compress\Compressjs;
use Kuoqi\Error;

/**
 * 内置站点启动
 * Class Httpd
 * @package Kuoqi\Cli
 */
class Package extends Behavior {
    protected $document = array(
        "打包当前站点，使用配置文件",
        "eq:php index.php package start -c D:/kuoqi/kuoqi-php-dev/kuoqi.json",
        "-c filename 自定义配置文件使用",
    );

    /**
     * @throws Error
     */
    public function start(){
        if($this->command=='help'){
            //启动服务的命令信息
            $this->help();//展示帮助方法
        }else{
            //启动服务的指令信息
            $this->doStart();
        }
    }

    //执行打包的基础信息
    public function doStart(){
        //将内容获取到并输出
        //配置文件的相关信息
        if (!isset($this->params['-c'])) {
            $this->error("请输入-c配置文件信息");
        }
        $fileDriver = new \Kuoqi\FileDriver($this->params['-c']);
        if (!$fileDriver->exist()) {
            $this->error("输入文件不存在，请检查");
        }
        $config = $fileDriver->readAsJson();
        var_dump($config);exit();
    }
}