<?php
namespace Kuoqi\Cli;

use Kuoqi\Cli\Compress\Compressjs;
use Kuoqi\Error;

class Server extends Behavior {
    protected $document = array(
        "[server]启动服务,效果等同于server start",
        "[server start]启动服务,有参数时必须使用这个启动后加入参数信息",
        "-c filename 使用自定义的配置文件进行",
    );
    /**
     * createby kuoqi at 2022/11/11 23:21 初始化start的方法
     * //php kuoqi.php compress js -i kuoqi-php.v1.00.03/application/test.js -o kuoqi-php.v1.00.03/application/test.min.js
     */
    public function start(){
        if($this->command=='start'){
            //启动服务的命令信息
            $this->doStart();
        }elseif($this->command=='help'){
            $this->help();//展示帮助方法
        }else{
            //启动服务的指令信息
            $this->doStart();
        }
    }

    //启动一个专业的服务，用于系统项目的传输的相关信息
    public function doStart(){
        $server = \Kuoqi\Config::get('SERVER');
        //$listen = $server['listen'];//监听的链接信息
        //$route = $server['route'];//监听的路由信息
        //启动一个socket进行监听信息
        $http = new \Kuoqi\Worker\Http('127.0.0.1','81','C:\www\kuoqi\kuoqi\php.v1.04\application');
        //开始执行
        if(!$http->start()){
            throw new Error($http->getError());
        }
    }
}