<?php
namespace Kuoqi\Cli;
use Kuoqi\DirDriver;

/**
 * Class Compress
 * @package Kuoqi\Cli
 * php index.php compress cfg -c C:\www\kuoqi\kuoqi-ui\css.json
 */
class Webmanage extends Behavior {

    protected $document = array(
        "[webmanage]",
        "服务器管理器，寄托于FTP的数据库配置信息，需要连接数据库基础然后进行使用"
        );
    /**
     * createby kuoqi at 2022/11/11 23:21 初始化start的方法
     * //php kuoqi.php compress js -i kuoqi-php.v1.00.03/application/test.js -o kuoqi-php.v1.00.03/application/test.min.js
     */
    public function start(){
        if($this->command == "pull"){
            $this->doPull();
        }else if($this->command == "push"){
            $this->doPush();
        }else{
            return $this->help();//展示帮助方法
        }
    }
    //执行pull
    protected function doPull(){  \Kuoqi::warn("pull");}
    protected function doPush(){
        \Kuoqi::warn("推送数据到服务器准备中.");
        $ftp_host = M('Configs')->where(array('name'=>'ftp_host'))->getOne('value');
        $ftp_port = M('Configs')->where(array('name'=>'ftp_port'))->getOne('value');
        $ftp_account = M('Configs')->where(array('name'=>'ftp_account'))->getOne('value');
        $ftp_mode = M('Configs')->where(array('name'=>'ftp_mode'))->getOne('value');
        $ftp_password = M('Configs')->where(array('name'=>'ftp_password'))->getOne('value');
        $ftp_locroot = M('Configs')->where(array('name'=>'ftp_locroot'))->getOne('value');
        if(!$ftp_port){
            M('Configs')->add(array(
                'name'=>'ftp_port',
                'value'=>'21',
                'type'=>'type',
            ));
            $ftp_port = M('Configs')->where(array('name'=>'ftp_port'))->getOne('value');
        }
        if(!$ftp_locroot){
            M('Configs')->add(array(
                'name'=>'ftp_locroot',
                'value'=>\Kuoqi\Route::str2rootpath('{@ROOT}'),
                'type'=>'type',
            ));
            $ftp_locroot = M('Configs')->where(array('name'=>'ftp_locroot'))->getOne('value');
        }

        $ftp_password = \Kuoqi\Openssl::decode(base64_decode($ftp_password),'','0000000000000000');
        \Kuoqi::warn("服务器链接中.");
        $ftpServer = \Kuoqi\Ftpserver::init(
            $ftp_host,
            $ftp_port,
            $ftp_account,
            $ftp_password
        );
        if(!$ftpServer->isValied()){
            return \Kuoqi::error('FTP初始化失败：'.$ftpServer->getError());
        }
        $ftpServer->setMode($ftp_mode);//启动被动模式
        $ftpServer->setRoot($ftp_locroot);
        $ftp_locroot = str_replace('\\','/',$ftp_locroot);
        $this->current_dir = str_replace('\\','/',$this->current_dir);
        //判断文件是否存在，当然只能是当前目录的文件
        if(isset($this->params['f'])){
            $dir = str_replace($ftp_locroot,'',$this->current_dir);
            $ftpServer->push($dir.'/'.$this->params['f']);
        }else{
            $dir = str_replace($ftp_locroot,'',$this->current_dir);
            $ftpServer->push($dir);
        }
    }
}