<?php
namespace Kuoqi\Cli\Compress;

class CompressWeb extends Behavior {
    public $content;
    //使用一个配置文件
    public function useConfig($config){
        $this->config = $config;
    }
    public function input($content){
        $this->content = $content;
    }
    public function output(){
        $config = $this->config;
        if(!isset($config['root'])){
            $this->errmsg = "请配置[root]参数";
            $this->errcode = -1;
            return $this->isValied();
        }
        if (!isset($config['output'])) {
            $this->errmsg = "请配置[output]参数";
            $this->errcode = -1;
            return $this->isValied();
        }
        if (!isset($config['list'])) {
            $this->errmsg = "请配置[list]参数";
            $this->errcode = -1;
            return $this->isValied();
        }
        \Kuoqi::warn("迁移文件开始");
        foreach ($config['list'] as $v){
            switch (\Kuoqi\FileDriver::stdExt($v['ord'])){
                case ".js":
                    //展示为JS文件
                    \Kuoqi::warn($this->path($v['ord']),false);
                    \Kuoqi::warn("->",false);
                    $gzip = new \Kuoqi\Gzip\JsGzip($this->path($v['ord']));
                    if($gzip->toFile($this->path($v['src']))){
                        \Kuoqi::warn($this->path($v['src']),false);
                        \Kuoqi::warn("成功");
                    }else{
                        \Kuoqi::warn("失败:".$gzip->getError());
                    }
                    break;
                case ".css":
                    //展示为CSS文件
                    \Kuoqi::warn($this->path($v['ord']),false);
                    \Kuoqi::warn("->",false);
                    $gzip = new \Kuoqi\Gzip\CssGzip($this->path($v['ord']));
                    if($gzip->toFile($this->path($v['src']))){
                        \Kuoqi::warn($this->path($v['src']),false);
                        \Kuoqi::warn("成功");
                    }else{
                        \Kuoqi::warn("失败:".$gzip->getError());
                    }
                    break;
                case ".html":
                    \Kuoqi::warn($this->path($v['ord']),false);
                    \Kuoqi::warn("->",false);
                    $gzip = new \Kuoqi\Gzip\HtmlGzip($this->path($v['ord']));
                    $gzip->flushConfig($this->config);
                    if($gzip->toFile($this->path($v['src']))){
                        \Kuoqi::warn($this->path($v['src']),false);
                        \Kuoqi::warn("成功");
                    }else{
                        \Kuoqi::warn("失败:".$gzip->getError());
                    }
                    break;
                default:
                    \Kuoqi::warn($this->path($v['ord']),false);
                    \Kuoqi::warn("->",false);
                    $gzip = new \Kuoqi\Gzip\CpGzip($this->path($v['ord']));
                    if($gzip->toFile($this->path($v['src']))){
                        \Kuoqi::warn($this->path($v['src']),false);
                        \Kuoqi::warn("成功");
                    }else{
                        \Kuoqi::warn("失败:".$gzip->getError());
                    }
                    ;break;
            }
        }
    }
}