<?php
namespace Kuoqi\Cli\Compress;

/**
 * Class Compressjs 压缩js的实现方法
 * @package Kuoqi\Cli\Compress
 * {
 * "root":"C:/www/kuoqi/kuoqi-ui",
 * "type":"css",
 * "version":"ui.1.02",
 * "input":"ui.dev.css",
 * "resource":[
 * {"ord":"library/fonts/kuoqi-Regular.ttf","src":"{@version}/fonts/kuoqi-Regular.ttf"}
 * ],
 * "output":"{@version}/kuoqi{@version}.min.css"
 * }
 */
class Compresscss extends Behavior {
    //protected $config = array();
    public $content;
    //使用一个配置文件
    public function useConfig($config){
        $this->config = $config;
    }
    public function input($content){
        $this->content = $content;
    }
    public function output(){
        $config = $this->config;
        if(!isset($config['root'])){
            $this->errmsg = "请配置[root]参数";
            $this->errcode = -1;
            return $this->isValied();
        }
        if (!isset($config['input'])) {
            $this->errmsg = "请配置[input]参数";
            $this->errcode = -1;
            return $this->isValied();
        }
        if (!isset($config['output'])) {
            $this->errmsg = "请配置[output]参数";
            $this->errcode = -1;
            return $this->isValied();
        }
        $css = new \Kuoqi\Kuoqiui\Css($this->path($config['input']));
        $fileDriver = new \Kuoqi\FileDriver($this->path($config['output']));
        $fileDriver->safe_code = "/**".PHP_EOL;
        $fileDriver->safe_code .= " * CSS Document".PHP_EOL;
        $fileDriver->safe_code .= " * compressby KuoqiPHP".PHP_EOL;
        $fileDriver->safe_code .= " * version ".$config['version'].PHP_EOL;
        $fileDriver->safe_code .= " * CreateDate ".date('Y-m-d H:i:s').PHP_EOL;
        $fileDriver->safe_code .= " */".PHP_EOL;
        $this->content = $css->output();
        $this->analysisNotesa();
        $this->analysisNotesb();
        $this->analysisSpacen();
        $fileDriver->setContent($this->content);
        $fileDriver->save();
        //进行资源的复制信息
        if(isset($config['resource'])){
            foreach ($config['resource'] as $k=>$v){
                if(is_array($v)){
                    $ordfile = new \Kuoqi\FileDriver($this->path($v['ord']));
                    $srcfile = new \Kuoqi\FileDriver($this->path($v['src']));
                }else{
                    $ordfile = new \Kuoqi\FileDriver($css->fileDriver->getPath().'/'.$v);
                    $srcfile = new \Kuoqi\FileDriver($fileDriver->getPath().'/'.$v);
                }
                $srcfile->setContent($ordfile->getContent());
                $srcfile->safe_code = "";
                $srcfile->save();
            }
        }
        return $this->isValied();
    }
}