<?php
namespace Kuoqi\Cli\Manage;
use Kuoqi\Error;

class ClientManage extends \Kuoqi\KuoqiException {

    public static function isDir($master,$dir){

        $master->postMessage(array(
            'scene'=>'isdir',
            'dir'=>$dir,
        ));
        return $master->onMessage(function($context){
            $data = json_decode($context,true);
            if(isset($data['scene'])){
                return $data['data'];
            }else{
                throw new Error("请求服务器异常");
            }
        });
    }

    public static function createDir($master,$dir){
        $master->postMessage(array(
            'scene'=>'createdir',
            'dir'=>$dir,
        ));
        $master->onMessage(function($context){
            $data = json_decode($context,true);
            if(isset($data['scene'])){
                if($data['data']){
                    return;
                }else{
                    throw new Error("创建服务器目录失败，无权限");
                }
            }else{
                throw new Error("请求服务器异常");
            }
        });
    }

    //liulanmu
    public static function scandir($master,$dir){
        $master->postMessage(array(
            'scene'=>'scandir',
            'dir'=>$dir,
        ));
        return $master->onMessage(function($context){
            $data = json_decode($context,true);
            if(isset($data['scene'])){
                $data = json_decode($context,true);
                $scene = \Kuoqi\Input::checkParam("scene","",$data);
                if($scene=='error'){
                    throw new Error(\Kuoqi::warn($scene["errmsg"]));
                }
                //如果没有结束，则这里进行后续的处理，然后判断文件是否在列表中
                return $data['data'];
            }else{
                throw new Error("请求服务器异常");
            }
        });
    }

    //推送文件到远端
    public static function pushFile($master,$webfilename,$localfile){

        $size = filesize($localfile);
        $master->postMessage(array(
            'scene'=>'pushfile',
            'filename'=>$webfilename,
            'filesize'=>$size
        ));

        $master->onMessage(function($context){
            $data = json_decode($context,true);
            if(isset($data['scene'])){
                if($data['scene']=='answer'){
                    return;
                }else{
                    throw new Error("传输文件异常：".$context);
                }
            }else{
                throw new Error("请求服务器异常");
            }
        });

        $stream = file_get_contents($localfile);
        $stream = base64_encode($stream);
        $master->postMessage($stream);//上传数据信息
        $master->onMessage(function($context){
            //上传文件数据获得的返回
            $data = json_decode($context,true);
            if(isset($data['scene'])){
                if($data['scene']=='ok'){
                    return;
                }else{
                    throw new Error("传输文件异常：".$context);
                }
            }else{
                throw new Error("请求服务器异常");
            }
        });
    }

    //获取忽略脚本的内容
    public static function ruleIgnore(){
        $context = '# 忽略的配置'.PHP_EOL;
        $context .= '# 每行一条数据信息'.PHP_EOL;
        $context .= '# 使用路径模式进行'.PHP_EOL;
        $context .= '# 参考如下的写法：eg'.PHP_EOL;
        $context .= '# /runtime'.PHP_EOL;
        return $context;
    }
    //获取替换脚本的内容
    public static function ruleReplace(){
        $context = "";
        $context .= "# 替换脚本".PHP_EOL;
        $context .= "# 每行一个数据信息".PHP_EOL;
        $context .= "# 可以在传输过程中自动替换文件的配置的信息".PHP_EOL;
        $context .= "# 参考如下的写法：eg:".PHP_EOL;
        $context .= "# /application/common/config.release.php /application/common/config.php".PHP_EOL;
        return $context;
    }
}