<?php
namespace Kuoqi\Cli\Manage;
class ServerManage extends \Kuoqi\KuoqiException {

    protected $port = 6522;//端口号信息
    protected $root = "";//站点跟目录
    protected $filename = "";//最近上传的文件名
    public function __construct($root)
    {
        \Kuoqi::warn("请输入manage服务器端的配置已使用");
        \Kuoqi::warn("请输入监听端口:",false);
        $this->port = \Kuoqi\Input::waitCliline();
        while (!$this->port){
            \Kuoqi::warn("请输入监听端口:",false);
            $this->port = \Kuoqi\Input::waitCliline();
        }
        \Kuoqi::warn("请绑定服务路径:",false);
        $this->root = $root;
        $socket = new \Kuoqi\Socket\Socket('0.0.0.0',$this->port,array());
        \Kuoqi::warn(sprintf("kuoqi-manage服务器已启用"));
        \Kuoqi::warn(sprintf("监听端口为:%s",$this->port));
        \Kuoqi::warn(sprintf("监听路径为:%s",$this->root));
        $socket->onMessage(function($message,$client,$server){
            \Kuoqi::warn("收到消息，长度为".strlen($message).' 内存消耗:'.memory_get_usage());
            $data = json_decode($message,true);
            if($data){
                //\Kuoqi::warn("收到JSON为:".$message);
                $scene = \Kuoqi\Input::checkParam("scene","",$data);
                //使用接口器的相关信息
                if($scene=="scandir"){
                    //进行一个目录浏览的操作
                    $dir = \Kuoqi\Input::checkParam("dir","",$data);
                    $server->postMessage($client,array(
                        'scene'=>'list',
                        'data'=>\Kuoqi\Cli\Manage\ServerManage::listDir($this->root,$dir),
                    ));
                }else if($scene=='isdir'){
                    //判断dir是否为目录
                    $dir = \Kuoqi\Input::checkParam("dir","",$data);
                    $server->postMessage($client,array(
                        'scene'=>'answer',
                        'data'=>is_dir($this->root.$dir)?1:0,
                    ));
                }else if($scene=='createdir'){
                    $dir = \Kuoqi\Input::checkParam("dir","",$data);
                    $server->postMessage($client,array(
                        'scene'=>'answer',
                        'data'=>@mkdir($this->root.$dir,0777,true)?1:0,
                    ));
                }else if($scene=='pushfile'){
                    //接收到客户端推送的文件

                    $this->filename = \Kuoqi\Input::checkParam("filename","",$data);
                    //$stream = \Kuoqi\Input::checkParam("stream","",$data);
                    //推送准备接收数据到远程端
                    //$stream = base64_decode($stream);
                    $server->postMessage($client,array(
                        'scene'=>'answer',
                        'errmsg'=>'成功',
                    ));
                }else{
                    $server->postMessage($client,array(
                        'scene'=>'error',
                        'errmsg'=>'无法识别的接口信息.v2',
                    ));
                }
            }else{
                //这个情况下是没有任何标识的信息，也就是所谓的文件上传
                if($this->filename){

                    if(\Kuoqi\Cli\Manage\ServerManage::pushFile($this->root,$this->filename,base64_decode($message))){
                        $server->postMessage($client,array(
                            'scene'=>'ok',
                            'errmsg'=>'文件传输完成',
                        ));
                    }else{
                        $server->postMessage($client,array(
                            'scene'=>'error',
                            'errmsg'=>'文件写入失败',
                        ));
                    }
                    $this->filename = "";
                }else{
                    $server->postMessage($client,array(
                        'scene'=>'error',
                        'errmsg'=>'文件传输异常',
                    ));
                }
            }
        });
        $socket->onConnect(function($client){
            \Kuoqi::warn("客户端".$client."链接成功");
        });
        $socket->start();//这里是最后的运行命令
    }


    public static function listDir($root,$dir){
        $dirDriver = new \Kuoqi\DirDriver($root.'/'.$dir);
        $list = $dirDriver->scanAsArray();
        //返回列表数据
        $optdata = array();
        foreach ($list as $item){
            $optdata[$item['path']] = $item['filemtime'];
        }
        return $optdata;
    }

    public static function pushFile($root,$filename,$stream){
        $fileDriver = new \Kuoqi\FileDriver($root.'/'.$filename);
        $fileDriver->safe_code = "";
        $fileDriver->setContent($stream);
        return $fileDriver->save();
    }
}