<?php
namespace Kuoqi\Com;
/**
 * 关于ffmpeg模块的相关执行
 * Class Ffmpeg
 * @package Kuoqi
 */
class Ffmpeg extends \Kuoqi\KuoqiException {
    public $server = null;//服务模块
    public function __construct()
    {
        $this->server = new \COM("KuoqiWorker.Ffmpeg");
    }

    //执行异步请求，异步请求返回进程ID
    public function async($comm){
        return $this->server->async($comm);
    }
    //执行同步请求,同步请求会输出内容
    public function sync($comm){
        return $this->server->sync($comm);
    }

    /**
     * 快速网络视频复制下载
     * @param $tsindex
     * @param $opt_uris
     * @param bool $isAync
     * @return mixed
     */
    public function downFromts($tsindex,$opt_uris,$isAync = true){
        $comm = sprintf('-i "%s" -vcodec copy -acodec copy -absf aac_adtstoasc %s'
            ,$tsindex
            ,$opt_uris
        );
        if($isAync){
            return $this->async($comm);
        }else{
            return $this->sync($comm);
        }
    }
}

