<?php
namespace Kuoqi\Curl;
/**
 * 初始化method带来的数据信息，返回一个设置列表
 * Class InitMethod
 * @package Kuoqi\Curl
 */
class InitMethod{
    public static $params = array();
    static public function methodWithGet($curl){
        $url = parse_url($curl->getUri());
        $arr = array();
        if(isset($url['query'])){
            $arr = \Kuoqi\Route::query2arr($url['query']);
        }
        $arr = array_merge($arr,$curl->getParams());
        $url['query'] = \Kuoqi\Route::arr2query($arr);
        $uri = $url['scheme'].'://'.$url['host']
            . (isset($url['path'])?$url['path']:"")
            . (isset($url['query'])?('?'.$url['query']):"")
            . (isset($url['fragment'])?('#'.$url['fragment']):"");
        $curl->setUri($uri);
        curl_setopt($curl->getResource(),CURLOPT_POST,false);
        curl_setopt($curl->getResource(),CURLOPT_POSTFIELDS,$curl->getParams());
        $curl->setHeader('Content-Type','text/html');
    }

    static public function methodWithPost($curl){
        $curl->setHeader('Content-Type','application/x-www-form-urlencoded');
        $curl->setMethod("POST");
        $params = $curl->getParams();
        curl_setopt($curl->getResource(),CURLOPT_POST,true);
        if(is_array($params)){
            if(PHP_VERSION>='5.5'){
                foreach ($params as $k=>$v){
                    if(is_array($v)){
                        $params[$k] = urlencode(json_encode($v,JSON_UNESCAPED_UNICODE));
                    }
                }
            }else{
                foreach ($params as $k=>$v){
                    if(is_array($v)){
                        $params[$k] = urlencode(json_encode($v));
                    }
                }
            }
            curl_setopt($curl->getResource(),CURLOPT_POSTFIELDS,http_build_query($params));
        }else{
            curl_setopt($curl->getResource(),CURLOPT_POSTFIELDS,$params);
        }
    }

    static public function methodWithForm($curl){
        $curl->setHeader('Content-Type','multipart/form-data');
        $curl->setMethod("POST");
        curl_setopt($curl->getResource(),CURLOPT_POST,true);
        curl_setopt($curl->getResource(),CURLOPT_POSTFIELDS,self::arr2form($curl->getParams()));
    }
    static public function methodWithXml($curl){
        $params = $curl->getParams();
        $curl->setMethod("POST");
        $curl->setHeader('Content-Type','application/json');
        curl_setopt($curl->getResource(),CURLOPT_POST,true);
        curl_setopt($curl->getResource(),CURLOPT_POSTFIELDS,$params);
    }
    static public function methodWithJson($curl){
        $curl->setHeader('Content-Type','application/json');
        $params = $curl->getParams();
        if(PHP_VERSION>='5.5'){
            $params = json_encode($params,JSON_UNESCAPED_UNICODE);
        }else{
            $params = json_encode($params);
        }
        $curl->setMethod("POST");
        curl_setopt($curl->getResource(),CURLOPT_POST,true);
        curl_setopt($curl->getResource(),CURLOPT_POSTFIELDS,$params);
    }

    final static function arr2form($arr,$tips = ''){
        if(!$arr){self::$params = array();return;}
        foreach($arr as $k=>$v){
            if(is_array($v)){
                self::arr2form($v,$tips?$tips.'['.$k.']':$k);
            }else{
                self::$params[$tips?$tips.'['.$k.']':$k] = $v;
            }
        }
        return self::$params;
    }

}