<?php
namespace Kuoqi\DbDriver\Sql;
use Kuoqi\Error;

class Field{
	
	public $params = array();

    /**
     * 简单的输入对象
     * vbase
     * Field constructor.
     * @param $fields
     */
	public function __construct($fields){
		//判定输入类型
		if(is_array($fields)){
			//判定输入类型为数组
			$fields = $fields;	
		}else if(is_string($fields)){
			//判定输入类型为字符串
			//进行字符串的基本切割
			$fields = explode(',',$fields);
		}

		//查看是否有[.]的符号在里面，如果有则自动切割
		foreach($fields as $k=>$v){
		    //判断是否为子语句，如果为子语句直接返回
            $v = trim($v);
            if(preg_match('/^\([\s\S]+/',$v)){
                $this->params[] = $v;
                continue;
            }
			$tmp = explode('.',$v);
            if(count($tmp)>1){
                $this->params[] = $v;
                continue;
            }
			$this->params[] = $this->valiValue($v);
		}
	}

    /**
     * 对字段进行封装
     * vbase
     * @param $value
     * @return string
     */
	public function valiValue($value){
		//判断是否函数语句
		if(preg_match('/\(/',$value)){
			//里面宇哥括号，则直接返回
			return $value;
		}
		//判定是否复杂的语句
		$code = explode(' ',$value);
		if(count($code)==1){
			$value = '`'.$value.'`';
		}
		return $value;
		
	}

	//单纯的输入
    public function input($fields){
        if(is_array($fields)){
            //判定输入类型为数组
           throw new Error("不支持的输入方法");
        }else if(is_string($fields)){
            //判定输入类型为字符串
            //进行字符串的基本切割
            $this->params[] = $fields;
        }
    }

    /**
     * 单纯的输出，格式化
     * vbase
     * @return string
     */
	public function output(){
		return implode(',',$this->params);
	}
	
}