<?php
namespace Kuoqi\FtpServer;
use Kuoqi\Error;

class Tools{

    //根据服务类型解析获取得到的数组为可识别的数组
    static public function explainDirlist($buffer,$dir){
        $type = ftp_systype($buffer);
        // $list = FtpServer\Tools::explainDirlist(ftp_rawlist($this->buffer,$this->dir),ftp_systype($this->buffer));
        switch ($type){
            case 'Windows_NT':return self::explainDirlistWithWIndowsNT($buffer,$dir);
            default:throw new Error("暂无解析FTP列表数据，类型为{$type}");
        }
    }

    //explainDirlistWithWIndowsNT
    //解析window_nt的列表
    static public function explainDirlistWithWIndowsNT($buffer,$dir){
        $list = ftp_rawlist($buffer,$dir,true);
        $data_dir = array();
        $data_file = array();
        foreach ($list as $item){
            $tmp = array();
            $item = preg_replace('/\s+/',' ',$item);
            $item = explode(' ',$item);
            if(count($item)==4){
                $datetime = preg_replace('/(\d+)-(\d+)-(\d+)/','20$3-$1-$2',$item[0]) .' '.$item[1];
                if($item[2]=='<DIR>'){
                    $tmp['path'] = $item[3];
                    $tmp['type'] ='DIR';
                    $tmp['type_msg'] = '文件夹';
                    $tmp['size'] = '';
                    $tmp['filemtime'] = $datetime;
                    $data_dir[] = $tmp;

                }else{
                    $tmp['path'] = $item[3];
                    $tmp['type'] = 'FILE';
                    $tmp['type_msg'] = substr(strrchr($item[3],'.'),1).'文件';
                    $tmp['size'] = $item[2];
                    //$tmp['filemtime'] = strtotime($date.' '.$item[1]);
                    $tmp['filemtime'] = $datetime;
                    $data_file[] = $tmp;
                }
            }else{
                throw new Error("解析WIndowsNT情况有变，请检查并补充完整");
            }
        }
        return array_merge($data_dir,$data_file);
    }

}