<?php
namespace Kuoqi\Gzip;

class CssGzip extends \Kuoqi\KuoqiException {
    protected $_ifiledriver = "";//当前传入的文件
    protected $stream = "";
    public function __construct($ifile,$opts = array())
    {
        $this->_ifiledriver = new \Kuoqi\FileDriver($ifile);
        if($this->_ifiledriver->exist()){
            $this->_ifiledriver->safe_code = "";
            $this->stream = $this->_ifiledriver->getContent();
        }else{
            $this->setError("解压缩JS文件不存在:".$ifile);
        }
    }

    //返回字符串的相关信息
    public function toStream(){
        $this->initImport();
        return $this->stream;
    }

    //返回写入文件的相关信息
    public function toFile($file){
        if(!$this->isValied()){
            return false;
        }
        $stream = $this->toStream();
        $file = new \Kuoqi\FileDriver($file);
        $file->safe_code = "";
        $file->setContent($stream);
        if($file->save()){
            return true;
        }else{
            $this->setError($file->getError());
            return false;
        }
    }

    /**
     * 初始化输入的相关信息
     */
    protected function initImport(){
        if(preg_match_all('/\@{0,1}import\s+\"(.+)\"\;/',$this->stream,$list)){
            //这个不存在的情况下不做任何处理
            //这个有文件的情况下，获取文件信息
            foreach ($list[0] as $k=>$itm){
                $path = $this->_ifiledriver->getPath();
                $file = $path .'/'. $list[1][$k];
                $css = new \Kuoqi\Kuoqiui\Css($file);
                $this->stream = str_replace($itm,$css->output(),$this->stream);
            }
        }
    }

}