<?php
namespace Kuoqi\Gzip;
/**
 * Class HtmlGzip
 * @package Kuoqi\Gzip
 * 代码复制，使用config的参数为{{CONFIG.params}}作为config文件配置获取的数据信息，只有在html中生效
 */
class HtmlGzip extends \Kuoqi\KuoqiException {
    protected $stream = "";
    public function __construct($ifile,$opts = array())
    {
        $file = new \Kuoqi\FileDriver($ifile);
        if($file->exist()){
            $file->safe_code = "";
            $this->stream = $file->getContent();
        }else{
            $this->setError("解压缩JS文件不存在:".$ifile);
        }
    }

    //返回字符串的相关信息
    public function toStream(){
        return $this->stream;
    }

    //返回写入文件的相关信息
    public function toFile($file){
        if(!$this->isValied()){
            return false;
        }
        $stream = $this->toStream();
        $file = new \Kuoqi\FileDriver($file);
        $file->safe_code = "";
        $file->setContent($stream);
        if($file->save()){
            return true;
        }else{
            $this->setError($file->getError());
            return false;
        }
    }

    /**
     * 参数配置的相关转义
     * @param array $config
     */
    public function flushConfig($config = array()){
        if(preg_match('/\{\{CONFIG\.(\w+)\}\}/',$this->stream,$list)){
            $this->stream = str_replace($list[0],(isset($config[$list[1]])?$config[$list[1]]:""),$this->stream);
            $this->flushConfig($config);
        }
    }
}