<?php
namespace Kuoqi\Input;
/**
 * 解释器，kuoqi的解释器
 * Class Explain
 * @package Kuoqi\Input
 */
class ProtocolInput extends \Kuoqi\KuoqiException {
    //关于所有的参数的相关信息
    protected $params = array();
    protected $host = "";
    public function __construct($link)
    {
        $arr = parse_url($link);
        if(!(isset($arr['scheme'])&&($arr['scheme']=='kuoqi'))){
            return $this->setError("scheme无法识别");
        }
        if(isset($arr['host'])){
            $this->host = $arr['host'];
        }else{
            return $this->setError("scheme无法识别");
        }
        if(isset($arr['query'])){
            $this->params = \Kuoqi\Route::query2arr($arr['query']);
        }else{
            return $this->setError("scheme无法识别");
        }
    }

    /**
     * 获取一个参数信息
     * @param $name
     * @param $defval
     * @return mixed
     */
    public function get($name,$defval = ""){
        return isset($this->params[$name])?$this->params[$name]:$defval;
    }

    /**
     * 核验host的参数信息
     * @param $host
     * @return bool
     */
    public function valihost($host){
        if($this->isValied()&&($this->host==$host)){
            return true;
        }else{
            return false;
        }
    }
}