<?php
namespace Kuoqi\Kuoqiui;
/**
 * 专属的一些快速操作，让操作更容易上手
 * Class AHtml
 * @package Kuoqi\Kuoqiui
 */
class Ahtml{

    /**
     * 常用的增加按钮
     * @param $action 权限内容
     * @param $url 打开链接
     * @param string $clsname cls名称
     * @param string $pagetitle 新窗口标题
     * @param string $w 新窗口宽度
     * @param string $h 新窗口高度
     * @return string Html
     */
    static public function Add($action,$url,$pagetitle = '新增',$clsname = 'btn btn-add',$w = '',$h = ''){
        if(!Power::valiAction('',$action)){ return '';}
        return sprintf('<a class="%s" kuoqiui-isloadpage data-title="%s" data-url="%s"  data-width="%s" data-height="%s"><i class="icon icon-add" style="display: inline-flex;float: left;"></i><span class="">新增</span></span></a>'
            ,$clsname
            ,$pagetitle
            ,$url
            ,$w
            ,$h
        );
    }

    /**
     * 编辑按钮
     * @param string $action
     * @param string $url
     * @param string $title
     * @param string $width
     * @param string $height
     * @return string
     */
    static function Edit($action = '',$url = '',$pagetitle = '编辑',$w = '',$h = ''){
        //判定权限
        if(!Power::valiAction('',$action)){ return '';}
        return sprintf('<a class="label" kuoqiui-isloadpage data-title="%s" data-url="%s"  data-width="%s" data-height="%s"><i class="icon icon-edit"></i></a>'
            ,$pagetitle
            ,$url
            ,$w
            ,$h
        );
    }

    /**
     * 删除按钮
     * @param string $action
     * @param string $url
     * @param string $title
     * @return string
     */
    static function Delete($action = '',$url = '',$title = ''){
        //判定权限
        if(!Power::valiAction('',$action)){ return '';}
        return sprintf('<a class="label" kuoqiui-isdel title="删除" data-title="%s" data-url="%s"><i class="icon icon-recycle"></i></a>'
            ,$title
            ,$url
        );
    }

    /**
     * createby kuoqi at 2022/8/30 14:18
     * @param string $action
     * @param string $url
     * @param string $text
     * @param string $title
     * @param string $class
     * @param string $width
     * @param int $height
     * @return string
     */
    static public function Ajax($action = '',$url = '',$text = '',$class = 'btn btn-small btn-index'){
        //判定权限
        if(!Power::valiAction('',$action)){ return '';}
        //判定权限
        return sprintf('<a class="%s" onclick="app.doAjax(this)" data-url="%s">%s</a>'
            ,$class
            ,$url
            ,$text
        );
    }

    /**
     * 关于加载的href的大小，绑定action的路由，有的时候显示，没有则隐藏,有权限控制
     * @param string $route 绑定路由信息
     * @param string $url url地址
     * @param string $text 展示内容
     * @param string $title 展示内容描述
     * @param string $class 使用class
     * @param string $width
     * @param int $height
     * @return string
     */
    static function Loadpage($action = '',$url = '',$text = '',$title = '',$class = 'btn btn-small btn-index',$width = 0,$height = 0){
        //判定权限
        if(!Power::valiAction('',$action)){ return '';}
        return sprintf('<a class="%s" kuoqiui-isloadpage title="%s" data-title="%s" data-url="%s" data-width="%s" data-height="%s">%s</a>'
            ,$class
            ,$title?$title:$text
            ,$title?$title:$text
            ,$url
            ,$width?$width:''
            ,$height?$height:''
            ,$text
        );
    }

    /**
     * 刷新按钮
     * @return string
     */
    static function Reload(){
        return '<a href="javascript:window.location.reload();" class="mg-5 label label-small"><i class="icon icon-refresh"></i><span>刷新</span></a>';
    }

    /**
     * 前端方法
     * @param string $route
     * @param string $funcname
     * @param string $text
     * @param string $title
     * @param string $class
     * @return string
     */
    static function Click($action = '',$funcname = '',$text = '',$dataurl = '',$class = 'btn btn-small btn-index'){
        //判定权限
        if(!Power::valiAction('',$action)){ return '';}
        return sprintf('<a class="%s" title="%s" data-title="%s" onclick="%s(this)" data-url="%s">%s</a>'
            ,$class
            ,$text
            ,$text
            ,$funcname
            ,$dataurl
            ,$text
        );
    }

    /**
     * 用最复杂的内容执行最简单的东西
     * Href 2024-07-24
     * @param string $action
     * @param string $url
     * @param string $text
     * @param string $title
     * @param string $class
     * @return string
     */
    static function Href($action = '',$url = '',$text = '',$title = '',$class = 'btn btn-small btn-index'){
        //判定权限
        if(!Power::valiAction('',$action)){ return '';}
        return sprintf('<a class="%s" title="%s"  href="%s">%s</a>'
            ,$class
            ,$title
            ,$url
            ,$text
        );
    }

    static function Open($action = '',$url = '',$text = '',$title = '',$class = 'btn btn-small btn-index'){
        //判定权限
        if(!Power::valiAction('',$action)){ return '';}
        return sprintf('<a target="_blank" class="%s" title="%s"  href="%s">%s</a>'
            ,$class
            ,$title
            ,$url
            ,$text
        );
    }

}