<?php
namespace Kuoqi\Kuoqiui;
use Kuoqi;
class DbCrumb{
    protected $object_db = null;//库对象
    protected $id = 0;//节点ID
    protected $param = '';//参数信息
    protected $items = array();//item信息
    protected $precode = '';//额外的前置代码内容
    public function __construct($db,$id,$showParam)
    {
        $this->object_db = $db;
        $this->id = $id;
        $this->param = $showParam;
    }

    /**
     * 根据多次查询数据库得到相关数据
     */
    protected function crumbItem(){
        $item = $this->object_db->where(array('id'=>$this->id))->field('id,pid,'.$this->param)->find();
        if($item){
            $this->items[] = $item;
            if($item['pid']>0){
                $this->id = $item['pid'];
                $this->crumbItem();
            }
        }
    }

    /**
     * 设置前置代码
     * setPrecode 2024-11-12
     * @param $code
     */
    public function setPrecode($code){
        $this->precode = $code;
    }

    /**
     * 监听没有个item的变化
     * toString 2024-11-12
     * @param $rsfunc
     * @param string $preString 额外的前置代码内容
     * @return string
     */
    public function toString($rsfunc){
        $this->crumbItem();//获取轮询的相关信息
        asort($this->items);
        $string = '';
        foreach ($this->items as $item){
            $string .= $rsfunc($item);
        }
        return '<div class="card card-crumb">'.$this->precode.$ex.$string.'</div>';
    }
}