<?php
namespace Kuoqi\Kuoqiui;
/**
 * 专属后台模板库，配合权限模块的相关信息，是html片段的良好导体
 * Class AHtml
 * @package App\Admin\Template
 */
class Form{
    static public $AUTO_NAMEWIDTH = true;//是否自动宽度的模式，如果是自动宽度的模式的话，会自动将宽度压缩
    static public $FORMAT_CODE = "flex";//格式化的基础字段信息，影响后续所有表单信息，这个值
    //获取对外可以使用的字段
    static public $NAME_LIST = array(
        'Text',
        'Textarea',
        'WxLocation',
        'Select',//多选选项
        'Image',//单图上传
        'Images',//多图上传
//        'Apihtml',
//        'Hide',
//        'Textunit',
//        'Tips',
//        'Password',
//        'Radio',
//        'Checkbox',
//        'Select',
//        'Editor',
//        'Img',
//        'Image',
//        'Upload',
    );
    //nametios
    static public $NAME_LIST_TIPS = array(
        'Text'=>'单行文本',
        'Textarea'=>'多行文本',
        'WxLocation'=>'微信定位',
        'Select'=>'选项列表',
        'Image'=>'单图片',
        'Images'=>'多图片',
    );

    //使用某个格式进行
    static public function format($format_code){
        self::$FORMAT_CODE = strtolower($format_code);
    }

    //初始化一个以下的字段，使用二维数组
    //对于显示的部分进行一个初始化的显示
    static public function InitItem($type,$config){
        self::$AUTO_NAMEWIDTH = true;
        if(!in_array($type,self::$NAME_LIST)){
            \Kuoqi::error(sprintf("\Kuoqi\Kuoqiui\Form::InitItem error : 没有该类型的初始化，类型为%s",$type));
            return "";
        }
        $content = "";
        switch ($type){
            case 'Text':$content = FormFormat::initText($config);break;
            case 'Textarea':$content = FormFormat::initTextarea($config);break;
            case 'WxLocation':$content = FormFormat::initWxLocation($config);break;
            case 'Image':$content = FormFormat::initImage($config);break;
            case 'Images':$content = FormFormat::initImages($config);break;
            case 'Select':$content = FormFormat::initSelect($config);break;
            case 'Slide':$content = FormFormat::initSlide($config);break;
            default:;
        }
        return $content;
    }

    /**
     * Apihtml 2024-08-15
     * @param $title
     * @param $name
     * @param string $defval
     * @param string $apiurl
     * @param string $apifuncname
     * @return string
     * @throws \Kuoqi\Error
     */
    static public function Apihtml($title,$name,$defval = '',$apiurl = '',$apifuncname = ''){
        $item = new \Kuoqi\Kuoqiui\Form\Item\ApihtmlItemForm(array(
            'is_require'=>0,
            'title'=>$title,
            'name'=>$name,
            'value'=>$defval,
            'format'=>self::$FORMAT_CODE,
            'url'=>$apiurl,
            'click'=>$apifuncname,
        ));
        return $item->toView();
    }

    /**
     * ApihtmlPost 2024-08-15
     * @param $title
     * @param $name
     * @param string $defval
     * @param string $apiurl
     * @param string $apifuncname
     * @return string
     * @throws \Kuoqi\Error
     */
    static public function ApihtmlPost($title,$name,$defval = '',$apiurl = '',$apifuncname = ''){
        $item = new \Kuoqi\Kuoqiui\Form\Item\ApihtmlItemForm(array(
            'is_require'=>0,
            'title'=>$title,
            'name'=>$name,
            'value'=>$defval,
            'format'=>self::$FORMAT_CODE,
            'url'=>$apiurl,
            'click'=>$apifuncname,
            'method'=>'post',//请求方式
        ));
        return $item->toView();
    }
    /**
     * 多选的列表
     * @param $title
     * @param $name
     * @param string $defval
     * @param array $list
     * @return string
     */
    static public function Checkbox($title,$name,$defval = '',$list = array()){
        $ipts = '';
        foreach ($list as $item){
            $ipts .= sprintf('<input name=\'data[%s][]\' type="checkbox" value=\'%s\' placeholder=\'%s\' data-value=\'%s\' />'
                ,$name
                ,$item['value']
                ,$item['name']
                ,$defval
            );
        }
        return sprintf('<div class="row-flex mgb-15 text-ch">
                <div class="col-auto">
                    <span class="label pdl-none %s">%s</span>
                </div>
                <div class="col-auto"><span class="label">:</span></div>
                <div class="col-other">
                    %s
                </div>
            </div>'
            ,self::$AUTO_NAMEWIDTH?"":"wdr-4"
            ,$title
            ,$ipts
        );
    }
    //只要日期
    static public function Date($title,$name,$defval = ''){
        $item = new \Kuoqi\Kuoqiui\Form\Item\DateItemForm(array(
            'is_require'=>0,
            'title'=>$title,
            'name'=>$name,
            'value'=>$defval,
            'format'=>self::$FORMAT_CODE,
        ));
        return $item->toView();
    }
    /**
     * 日期和时间的具体选择
     * Datetime 2024-08-16
     * @param $title
     * @param $name
     * @param string $defval
     * @return string
     * @throws \Kuoqi\Error
     */
    static public function Datetime($title,$name,$defval = ''){
        $item = new \Kuoqi\Kuoqiui\Form\Item\DatetimeItemForm(array(
            'is_require'=>0,
            'title'=>$title,
            'name'=>$name,
            'value'=>$defval,
            'format'=>self::$FORMAT_CODE,
        ));
        return $item->toView();
    }
    /**
     * @param $title
     * @param $name
     * @param string $defval
     * @return string
     */
    static public function Editor($title,$name,$defval=''){
        return sprintf('<div class="row-flex mgb-15 text-ch">
                <div class="col-auto">
                    <span class="label pdl-none %s">%s</span>
                </div>
                <div class="col-auto"><span class="label">:</span></div>
                <div class="col-other" style="padding: 2px;border: 1px solid #dedede;border-radius: 0.25rem;">
                    <textarea name=\'data[%s]\' type="editor" data-name=\'data[%s-editor]\'>%s</textarea>
                </div>
            </div>'
            ,self::$AUTO_NAMEWIDTH?"":"wdr-4"
            ,$title
            ,$name
            ,$name
            ,htmlentities($defval)
        );
    }
    static public function File($title,$name,$defval = '',$url = ''){
        $item = new \Kuoqi\Kuoqiui\Form\Item\FileItemForm(array(
            'is_require'=>0,
            'title'=>$title,
            'name'=>$name,
            'value'=>$defval,
            'format'=>self::$FORMAT_CODE,
            'data'=>$url,
        ));
        return $item->toView();
    }
    /**
     * 隐藏的字段信息
     * @param $name
     * @param string $defval
     * @return string
     */
    static public function Hide($name,$defval = ''){
        return sprintf(' <input name=\'data[%s]\' hidden value=\'%s\' />'
            ,$name
            ,$defval
        );
    }
    /**
     * @param $title
     * @param $name
     * @param string $defval
     * @param string $url
     * @param int $format_w
     * @param int $format_h
     * @param int $upw
     * @param int $uph
     * @return string
     */
    static public function Img($title,$name,$defval = '',$url = '',$format_w = 0,$format_h=0,$upw=0,$uph=0){
        return sprintf('<div class="row-flex mgb-15 text-ch">
                <div class="col-auto">
                    <span class="label pdl-none %s">%s</span>
                </div>
                <div class="col-auto"><span class="label">:</span></div>
                <div class="col-other">
                    <input type="image-simple" name=\'data[%s]\' value=\'%s\' data-url=\'%s\' class="form-input" data-format_width="%s" data-format_height="%s" data-width="%s" data-height="%s"  />
                </div>
            </div>'
            ,self::$AUTO_NAMEWIDTH?"":"wdr-4"
            ,$title
            ,$name
            ,$defval
            ,$url
            ,$format_w?$format_w:'4rem'
            ,$format_h?$format_h:'4rem'
            ,$upw?$upw:0
            ,$uph?$uph:0
        );
    }
    /**
     * 图片模块的相关展示
     * @param $title
     * @param $name
     * @param string $defval
     * @return string
     */
    static public function Image($title,$name,$defval = '',$url = ''){
        return sprintf('<div class="row-flex mgb-15 text-ch">
                <div class="col-auto">
                    <span class="label pdl-none %s">%s</span>
                </div>
                <div class="col-auto"><span class="label">:</span></div>
                <div class="col-other">
                    <input type="image-simple" name=\'data[%s]\' value=\'%s\' data-url=\'%s\' class="form-input"  />
                </div>
            </div>'
            ,self::$AUTO_NAMEWIDTH?"":"wdr-4"
            ,$title
            ,$name
            ,$defval
            ,$url
        );
    }
    /**
     * 多图片上传的模块信息
     * @param $title
     * @param $name
     * @param string $defval
     * @param string $url
     * @return string
     */
    static public function Images($title,$name,$defval = '',$url = ''){
        return sprintf('<div class="row-flex mgb-15 text-ch">
                <div class="col-auto">
                    <span class="label pdl-none %s">%s</span>
                </div>
                <div class="col-auto"><span class="label">:</span></div>
                <div class="col-other">
                    <input type="imgs" name=\'data[%s]\' value=\'%s\' data-url=\'%s\' class="form-input"  />
                </div>
            </div>'
            ,self::$AUTO_NAMEWIDTH?"":"wdr-4"
            ,$title
            ,$name
            ,$defval
            ,$url
        );
    }

    /**
     * 多标签的输入
     * Labels 2024-08-20
     * @param $title
     * @param $name
     * @param string $defval
     * @return string
     * @throws \Kuoqi\Error
     */
    static public function Labels($title,$name,$defval = ''){
        $item = new \Kuoqi\Kuoqiui\Form\Item\labelsItemForm (array(
            'is_require'=>0,
            'title'=>$title,
            'name'=>$name,
            'value'=>$defval,
            'format'=>self::$FORMAT_CODE,
        ));
        return $item->toView();
    }
    /**
     * 用户修改密码框
     * @param $title
     * @param $name
     * @param string $desc
     * @return string
     */
    static public function Password($title,$name,$desc = ''){
        return sprintf('<div class="row-flex mgb-15 text-ch">
                    <div class="col-auto">
                        <span class="label pdl-none %s">%s</span>
                    </div>
                    <div class="col-auto"><span class="label">:</span></div>
                    <div class="col-other">
                        <input type="password" name=\'data[%s]\' value="" class="form-input" placeholder=\'%s\' />
                    </div>
                </div>'
            ,self::$AUTO_NAMEWIDTH?"":"wdr-4"
            ,$title
            ,$name
            ,$desc
        );
    }
    /**
     * radio模块的使用
     * @param $title
     * @param $name
     * @param string $defval
     * @param array $list
     * @return string
     */
    static public function Radio($title,$name,$defval = '',$list = array()){
        $ipts = '';
        foreach ($list as $item){
            $ipts .= sprintf('<input name=\'data[%s]\' type="radio" value=\'%s\' placeholder=\'%s\' data-value=\'%s\' />'
                ,$name
                ,$item['value']
                ,$item['name']
                ,$defval
            );
        }
        return sprintf('<div class="row-flex mgb-15 text-ch">
                <div class="col-auto">
                    <span class="label pdl-none %s">%s</span>
                </div>
                <div class="col-auto"><span class="label">:</span></div>
                <div class="col-other">
                    %s
                </div>
            </div>'
            ,self::$AUTO_NAMEWIDTH?"":"wdr-4"
            ,$title
            ,$ipts
        );
    }
    /**
     * 选择框
     * @param $title
     * @param $name
     * @param string $defval
     * @param string $apiurl
     * @return string
     */
    static public function Select($title,$name,$defval = '',$apiurl = ''){
        if(is_array($apiurl)){
            $item = new \Kuoqi\Kuoqiui\Form\Item\SelectItemForm (array(
                'is_require'=>0,
                'title'=>$title,
                'name'=>$name,
                'value'=>$defval,
                'format'=>self::$FORMAT_CODE,
                'data'=>$apiurl,
            ));
            return $item->toView();
        }else{
            return sprintf('<div class="row-flex mgb-15 text-ch">
                <div class="col-auto">
                    <span class="label pdl-none %s">%s</span>
                </div>
                <div class="col-auto"><span class="label">:</span></div>
                <div class="col-other">
                    <select class="form-select" type="api" name=\'data[%s]\' data-url=\'%s\' data-value=\'%s\'>==请选择==</select>
                </div>
            </div>'
                ,self::$AUTO_NAMEWIDTH?"":"wdr-4"
                ,$title
                ,$name
                ,$apiurl
                ,$defval
            );
        }

    }
    static public function Slide($title,$name,$defval = '',$url = ''){
        return sprintf('<div class="row-flex mgb-15 text-ch">
                <div class="col-auto">
                    <span class="label pdl-none %s">%s</span>
                </div>
                <div class="col-auto"><span class="label">:</span></div>
                <div class="col-other">
                    <input type="imgurls" name=\'data[%s]\' value=\'%s\' data-url=\'%s\' class="form-input"  />
                </div>
            </div>'
            ,self::$AUTO_NAMEWIDTH?"":"wdr-4"
            ,$title
            ,$name
            ,$defval
            ,$url
        );
    }
    /**
     * form表单提交Text的文本内容的方法
     * Text 2024-07-31
     * @param $title
     * @param $name
     * @param string $defval
     * @param string $desc
     * @return string
     */
    static public function Text($title,$name,$defval = '',$desc = ''){
        $driver = new Form\Item\TextItemForm(array(
            'is_require'=>0,
            'title'=>$title,
            'name'=>$name,
            'value'=>$defval,
            'format'=>self::$FORMAT_CODE,
            'tips'=>$desc?$desc:("请填写".$title)
        ));
        return $driver->toView();
    }
    /**
     * textarea
     * @param $title
     * @param $name
     * @param string $defval
     * @param string $desc
     * @return string
     */
    static public function Textarea($title,$name,$defval = '',$desc = '',$rowcol = 6){
        $driver = new Form\Item\TextareaItemForm(array(
            'is_require'=>0,
            'title'=>$title,
            'name'=>$name,
            'value'=>$defval,
            'data'=>$rowcol,
            'format'=>self::$FORMAT_CODE,
            'tips'=>$desc?$desc:("请填写".$title)
        ));
        return $driver->toView();
    }
    /**
     * marked的文档部分的标签
     * @param $title
     * @param $name
     * @param string $defval
     * @return string
     */
    static public function TextMarked($title,$name,$defval = ''){
        return sprintf('<div class="row-flex mgb-15 text-ch">
                <div class="col-auto">
                    <span class="label pdl-none %s">%s</span>
                </div>
                <div class="col-auto"><span class="label">:</span></div>
                <div class="col-other">
                    <textarea name=\'data[%s]\' type="editor" data-name=\'data[%s-editor]\'>%s</textarea>
                </div>
            </div>'
            ,self::$AUTO_NAMEWIDTH?"":"wdr-4"
            ,$title
            ,$name
            ,$name
            ,$defval
        );
    }
    /**
     * 富文本
     * @param $title
     * @param $name
     * @param string $defval
     * @return string
     */
    static public function TextRich($title,$name,$defval=''){
        return sprintf('<div class="row-flex mgb-15 text-ch">
                <div class="col-auto">
                    <span class="label pdl-none %s">%s</span>
                </div>
                <div class="col-auto"><span class="label">:</span></div>
                <div class="col-other" style="padding: 2px;border: 1px solid #dedede;border-radius: 0.25rem;">
                    <textarea name=\'data[%s]\' type="richtext" data-name=\'data[%s-editor]\'>%s</textarea>
                </div>
            </div>'
            ,self::$AUTO_NAMEWIDTH?"":"wdr-4"
            ,$title
            ,$name
            ,$name
            ,$defval
        );
    }
    /**
     * 单个字段后面带一个内容的那种表格
     * @param $title
     * @param $name
     * @param string $defval
     * @param string $desc
     * @param string $unit
     * @return string
     */
    static public function Textunit($title,$name,$defval = '',$desc = '',$unit = ''){
        return sprintf('<div class="row-flex mgb-15 text-ch">
                    <div class="col-auto">
                        <span class="label pdl-none %s">%s</span>
                    </div>
                    <div class="col-auto"><span class="label">:</span></div>
                    <div class="col-other">
                        <div class="form-input">
                            <input name=\'data[%s]\' value=\'%s\' placeholder=\'%s\' />
                            <span class="">%s</span>
                        </div>
                    </div>
                </div>'
            ,self::$AUTO_NAMEWIDTH?"":"wdr-4"
            ,$title
            ,$name
            ,$defval
            ,$desc?$desc:("请填写".$title)
            ,$unit
        );
    }
    /**
     * tips
     * @param $tips
     * @return string
     */
    static public function Tips($tips){
        return sprintf('<div class="row-flex text-ch">
                    <div class="col-other">
                    <span class="label pdl-none label-tips">%s</span>
                    </div>
                </div>'
            ,$tips
        );
    }
    /**
     * 上传文件
     * @param $title
     * @param $name
     * @param string $defval
     * @param string $upload_url
     * @return string
     */
    static public function Upload($title,$name,$defval = '',$upload_url = ''){
        return sprintf('<div class="row-flex mgb-15 text-ch">
                <div class="col-auto">
                    <span class="label pdl-none %s">%s</span>
                </div>
                <div class="col-auto"><span class="label">:</span></div>
                <div class="col-other">
                    <input type="upload" name=\'data[%s]\' value=\'%s\' data-url=\'%s\' class="form-input"  />
                </div>
            </div>'
            ,self::$AUTO_NAMEWIDTH?"":"wdr-4"
            ,$title
            ,$name
            ,$defval
            ,$upload_url
        );
    }
    /**
     * 微信生态中获取微信定位的部分
     * @param $title
     * @param $name
     * @param string $defval
     * @param string $url
     * @return string
     */
    static public function WxLocation($title,$name,$defval = '',$url = ''){
        return sprintf('<div class="row-flex mgb-15 text-ch">
                <div class="col-auto">
                    <span class="label pdl-none %s">%s</span>
                </div>
                <div class="col-auto"><span class="label">:</span></div>
                <div class="col-other">
                    <input type="wxlocation" name=\'data[%s]\' value=\'%s\' data-url=\'%s\' placeholder="点击右侧定位获取位置" class="form-input"  />
                </div>
            </div>'
            ,self::$AUTO_NAMEWIDTH?"":"wdr-4"
            ,$title
            ,$name
            ,$defval
            ,$url
        );
    }
}