<?php
namespace Kuoqi\Kuoqiui;
use Kuoqi\Error;

/**
 * 专门给form表单传输数据的
 * Class FormFormat
 * @package Kuoqi\Kuoqiui
 */
class FormFormat{
    //初始化text的数据模块
    static public function initText($config){
        $title = '';
        $name = '';
        $defval = '';
        $desc = '';
        if(isset($config['title'])){ $title = $config['title'];}
        if(isset($config['name'])){ $name = $config['name'];}
        if(isset($config['defval'])){ $defval = $config['defval'];}
        if(isset($config['desc'])){ $desc = $config['desc'];}
        $stream = "";
        if($desc){
            $stream .= Form::Tips($config['desc']);
        }
        $stream .= Form::Text($title,$name,$defval,$desc);
        return $stream;
    }
    //初始化textarea的数据模块
    static public function initTextarea($config){
        $title = '';
        $name = '';
        $defval = '';
        $desc = '';
        $rowcol = 6;
        if(isset($config['title'])){ $title = $config['title'];}
        if(isset($config['name'])){ $name = $config['name'];}
        if(isset($config['defval'])){ $defval = $config['defval'];}
        if(isset($config['desc'])){ $desc = $config['desc'];}
        $stream = "";
        if($desc){
            $stream .= Form::Tips($config['desc']);
        }
        $stream .=  Form::Textarea($title,$name,$defval,$desc,$rowcol);
        return $stream;
    }
    //初始化微信定位的表单模块书籍
    static public function initWxLocation($config){
        $title = '';
        $name = '';
        $defval = '';
        $desc = '';
        $url = url("api/tencentmap/local2desc");
        if(isset($config['title'])){ $title = $config['title'];}
        if(isset($config['name'])){ $name = $config['name'];}
        if(isset($config['defval'])){ $defval = $config['defval'];}
        if(isset($config['desc'])){ $desc = $config['desc'];}
        if(isset($config['url'])){ $desc = $config['url'];}
        $stream = "";
        if($desc){
            $stream .= Form::Tips($config['desc']);
        }
        $stream .= Form::WxLocation($title,$name,$defval,$url);
        return $stream;
    }
    static public function initImage($config)
    {
        $title = '';
        $name = '';
        $defval = '';
        $desc = '';
        if(isset($config['title'])){ $title = $config['title'];}
        if(isset($config['name'])){ $name = $config['name'];}
        if(isset($config['defval'])){ $defval = $config['defval'];}
        if(isset($config['desc'])){ $desc = $config['desc'];}
        $url = url("api/upload/image");
        $extconfig = json_decode($config['ext_config'],true);
        if(isset($extconfig['url'])){
            if(isset($extconfig['url'])){ $url = $extconfig['url'];}
        }
        $stream = "";
        if($desc){
            $stream .= Form::Tips($config['desc']);
        }
        $stream .=  Form::Image($title,$name,$defval,$url);
        return $stream;
    }
    static public function initSlide($config)
    {
        $title = '';
        $name = '';
        $defval = '';
        $desc = '';
        if(isset($config['title'])){ $title = $config['title'];}
        if(isset($config['name'])){ $name = $config['name'];}
        if(isset($config['defval'])){ $defval = $config['defval'];}
        if(isset($config['desc'])){ $desc = $config['desc'];}
        $url = url("api/upload/image");
        $extconfig = json_decode($config['ext_config'],true);
        if(isset($extconfig['url'])){
            if(isset($extconfig['url'])){ $url = $extconfig['url'];}
        }
        $stream = "";
        if($desc){
            $stream .= Form::Tips($config['desc']);
        }
        $stream .=  Form::Slide($title,$name,$defval,$url);
        return $stream;
    }
    static public function initImages($config)
    {
        $title = '';
        $name = '';
        $defval = '';
        $desc = '';
        if(isset($config['title'])){ $title = $config['title'];}
        if(isset($config['name'])){ $name = $config['name'];}
        if(isset($config['defval'])){ $defval = $config['defval'];}
        if(isset($config['desc'])){ $desc = $config['desc'];}
        $url = url("api/upload/image");
        $extconfig = json_decode($config['ext_config'],true);
        if(isset($extconfig['url'])){
            if(isset($extconfig['url'])){ $url = $extconfig['url'];}
        }
        $stream = "";
        if($desc){
            $stream .= Form::Tips($config['desc']);
        }
        $stream .=  Form::Images($title,$name,$defval,$url);
        return $stream;
    }
    //初始化一个简单的列表
    static public function initSelect($config){
        $title = '';
        $name = '';
        $defval = '';
        $desc = '';
        $extconfig = json_decode($config['ext_config'],true);
        if(isset($extconfig['select_list'])){
            $select_list = explode(',',$extconfig['select_list']);
        }else{
            $select_list = array();
        }
        $option_stream = "";
        foreach ($select_list as $item){
            $option_stream.= sprintf('<option value="%s">%s</option>',$item,$item);
        }
        if(isset($config['title'])){ $title = $config['title'];}
        if(isset($config['name'])){ $name = $config['name'];}
        if(isset($config['defval'])){ $defval = $config['defval'];}
        if(isset($config['desc'])){ $desc = $config['desc'];}
        if(isset($config['url'])){ $url = $config['url'];}
        $stream = "";
        if($desc){
            $stream .= Form::Tips($config['desc']);
        }
        $stream .= sprintf('<div class="row-flex mgb-15 text-ch">
                <div class="col-auto">
                    <span class="label pdl-none %s">%s</span>
                </div>
                <div class="col-auto"><span class="label">:</span></div>
                <div class="col-other">
                    <select class="form-select" name="data[%s]" data-value="%s">%s</select>
                </div>
            </div>'
            ,FORM::$AUTO_NAMEWIDTH?"":"wdr-4"
            ,$title
            ,$name
            ,$defval
            ,$option_stream
        );;
        return $stream;
    }
}