<?php
namespace Kuoqi\Kuoqiui;
/**
 * 关于树枝列表信息
 * Class Tree
 * @package Kuoqi\Kuoqiui
 */
class Tree extends \Kuoqi\KuoqiException {
    protected $data = array();
    protected $index = 'id';
    protected $roop = 'pid';
    protected $stream = "";

    /**
     * Tree constructor.
     * @param $data 使用数据进行初始化
     */
    public function __construct($data)
    {
        $this->data = $data;
    }

    /**
     * 输出为自定义卡片
     * @param $pid 上级的节点索引
     * @param $itemcallback
     * @return string 返回完成的字符串信息
     */
    public function toCardCustom($pid,$itemcallback){
        return sprintf('<div class="card card-tree">%s</div>',$this->toCardCustonContent($pid,$itemcallback,0));
    }

    /**
     * 执行卡片的额详情
     * @param $pid
     * @param $itemcallback
     * @return string
     */
    protected function toCardCustonContent($pid,$itemcallback,$deep){
        $this->data;
        $stream = '';
        foreach ($this->data as $v){
            if($v[$this->roop]==$pid){
                $str = sprintf('<div class="branch-body"><div class="tree-content">%s</div></div>',$itemcallback($v,$deep));
                foreach ($this->data as $sv){
                    if($sv[$this->roop]==$v[$this->index]){
                        $str .= $this->toCardCustonContent($v[$this->index],$itemcallback,$deep);
                        break;
                    }
                }
                $stream .= sprintf('<div class="tree-branch">%s</div>',$str);
            }
        }
        return $stream;
    }

    /**
     * fromSymbol 根据固定分隔符数据生成内容
     * fromSymbol 2024-11-04
     * @param $data
     * @param $code
     * @param $index
     * @param $symbol
     * @return string
     */
    public static function fromSymbol($data,$code,$index,$symbol,$ids){
        //数据的基础处理
        $arr = array();
        foreach ($data as $k=>$v){
            $tmp = explode($symbol,$v[$code]);
            $point = &$arr;
            foreach ($tmp as $temp){
                if(!isset($point[$temp])){
                    $point[$temp] = array($code=>$temp,$index=>$data[$k][$index],"list"=>array());
                }
                $point = &$point[$temp]["list"];
            }
        }
        $stream = self::symbolContent($arr,$code,$index);
        return sprintf('<div class="card card-tree tree-incheckbox" data-index="%s" data-ids="%s">%s</div>'
            ,$index
            ,$ids
            ,$stream
        );
    }

    public static function symbolContent($arr,$code,$index){
        $stream = '';
        foreach ($arr as $item){
            $stream .= '<div class="tree-branch">';
            $stream .= sprintf('<label class="branch-body" data-id="%s"><div class="branch-content"><span>%s</span></div></label>'
                ,$item[$index]
                ,$item[$code]
            );
            if(count($item['list'])){
                $stream .= self::symbolContent($item['list'],$code,$index);
            }
            $stream .= '</div>';
        }
        return $stream;
    }

    //显示为代码
    public function toView(){
        return $this->stream;
    }
}