<?php
namespace Kuoqi\Kuoqiui\Form\Item;
use Kuoqi\Error;
use Kuoqi\Kuoqiui\Form\ItemForm;

/**
 * 一个图片的常规提交
 * Class ImageItemForm
 * @package Kuoqi\Kuoqiui\Form\Item
 */
class ImageItemForm extends ItemForm {
    protected $config = array();
    /**
     * 一个字段的参数的初始化
     * ItemForm constructor.
     * @param array $opts
     */
    public function __construct($opts = array())
    {
        parent::__construct($opts);
    }

    //显示为视图的文件内容
    public function toView(){
        if($this->format=="flex"){
            return sprintf('<div class="row-flex mgb-15 text-ch">
                    <div class="col-auto">
                        <span class="label pdl-none">%s%s</span>
                    </div>
                    <div class="col-auto"><span class="label">:</span></div>
                    <div class="col-other">
                        <input type="image-simple" name=\'data[%s]\' value=\'%s\' class="form-input" placeholder=\'%s\' data-url="%s" />
                    </div>
                </div>'
                ,$this->is_require?'<span class="pdremr-2">*</span>':''
                ,$this->title
                ,$this->name
                ,$this->value
                ,$this->tips
                ,$this->data
            );
        }else if($this->format=="card"){
            return trim(sprintf('<div class="card mgb-15 text-ch">
                    <div class="card-head"><span class="label pdl-none">%s%s</span></div>
                    <div class="card-body"><input ype="image-simple" name=\'data[%s]\' value=\'%s\' class="form-input" placeholder=\'%s\' data-url="%s" /></div>
                    <div class="card-foot"><span class="label pdl-none label-tips">%s</span></div>
                </div>'
                ,$this->is_require?'<span class="pdremr-2">*</span>':''
                ,$this->title
                ,$this->name
                ,$this->value
                ,$this->tips
                ,$this->data
                ,$this->desc
            ));
        }else{
            throw new Error("暂不支持".$this->format."布局方式");
        }
    }

    //显示个客户端的样子
    public function toCustom($data){
        $stream = "";
        if($this->format=="flex"){
            $stream .= trim(sprintf('<div class="row-flex">
                <div class="col-auto"><span class="label pdl-none">%s：</span></div>
                <div class="col-other"><span class="label pdl-none">%s</span></div>
                </div>'
                ,$this->title
                ,$data
            ));
        }else if($this->format=="card"){
            $stream .= trim(sprintf('<div class="card mgb-15 text-ch">
                    <div class="card-head"><span class="label pdl-none">%s：</span></div>
                    <div class="card-body"><input readonly class="form-input" value="%s" /></div>
                    <div class="card-foot"></div>
                </div>'
                ,$this->title
                ,$data
            ));
        }else if($this->format=="simple"){
            return $this->toCustomWithSimple($data);
        }else{
            throw new Error("暂不支持".$this->format."布局方式");
        }
        return $stream;
    }
}