<?php
namespace Kuoqi\Kuoqiui\Form\Item;
use Kuoqi\Error;
use Kuoqi\Kuoqiui\Form\ItemForm;

/**
 * 一个上传多图的表单项
 * Class ImagesItemForm
 * @package Kuoqi\Kuoqiui\Form\Item
 */
class ImagesItemForm extends ItemForm {
    protected $config = array();
    /**
     * 一个字段的参数的初始化
     * ItemForm constructor.
     * @param array $opts
     */
    public function __construct($opts = array())
    {
        parent::__construct($opts);
    }

    //显示为视图的文件内容
    public function toView(){
        if($this->format=="flex"){
            return sprintf('<div class="row-flex mgb-15 text-ch">
                    <div class="col-auto">
                        <span class="label pdl-none">%s%s</span>
                    </div>
                    <div class="col-auto"><span class="label">:</span></div>
                    <div class="col-other">
                        <input type="imgs" name=\'data[%s]\' value=\'%s\' class="form-input" placeholder=\'%s\' data-url="%s" />
                    </div>
                </div>'
                ,$this->is_require?'<span class="pdremr-2">*</span>':''
                ,$this->title
                ,$this->name
                ,$this->value
                ,$this->tips
                ,$this->data
            );
        }else if($this->format=="card"){
            return trim(sprintf('<div class="card mgb-15 text-ch">
                    <div class="card-head"><span class="label pdl-none">%s%s</span></div>
                    <div class="card-body">
                        <input type="imgs" name=\'data[%s]\' value=\'%s\' class="form-input" placeholder=\'%s\' data-url="%s" />
                    </div>
                    <div class="card-foot"><span class="label pdl-none label-tips">%s</span></div>
                </div>'
                ,$this->is_require?'<span class="pdremr-2">*</span>':''
                ,$this->title
                ,$this->name
                ,$this->value
                ,$this->tips
                ,$this->data
                ,$this->desc
            ));
        }else{
            throw new Error("暂不支持".$this->format."布局方式");
        }
    }

    //显示个客户端的样子
    public function toCustom($data){
        $stream = "";
        //$data = $this->getCustomDatastream($data);
        if($this->format=="flex"){
            $stream .= trim(sprintf('<div class="row-flex">
                <div class="col-auto"><span class="label pdl-none">%s：</span></div>
                <div class="col-other"><span class="label pdl-none">%s</span></div>
                </div>'
                ,$this->title
                ,$data
            ));
        }else if($this->format=="card"){
            $stream .= trim(sprintf('<div class="card mgb-15 text-ch">
                    <div class="card-head"><span class="label pdl-none">%s：</span></div>
                    <div class="card-body"><input readonly type="imgs" class="form-input" value="%s" /></div>
                    <div class="card-foot"></div>
                </div>'
                ,$this->title
                ,$data
            ));
        }else if($this->format=="simple"){
            return $this->toCustomWithSimple($data);
        }else{
            throw new Error("暂不支持".$this->format."布局方式");
        }
        return $stream;
    }

    //将内容转换为表格的信息
    public function getCustomDatastream($data){
        $box =  '<div class="card card-form-item">%s</div>';
        $stream = "";
        $data = json_decode($data,true);
        if($data!=null){
            foreach ($data as $item){
                $stream .= sprintf('<div class="card card-image">
                    <img src="%s" />
                </div>'
                    ,$item['url']
                );
            }
        }
        return sprintf($box,$stream);
    }

}