<?php
namespace Kuoqi\Kuoqiui\Form\Item;
use Kuoqi\Error;
use Kuoqi\Kuoqiui\Form\ItemForm;

/**
 * 一个单选的选项
 * Class RadioItemForm
 * @package Kuoqi\Kuoqiui\Form\Item
 */
class RadioItemForm extends ItemForm {
    protected $config = array();
    /**
     * 一个字段的参数的初始化
     * ItemForm constructor.
     * @param array $opts
     */
    public function __construct($opts = array())
    {
        parent::__construct($opts);
    }

    //显示为视图的文件内容
    public function toView(){
        $stream = "";
        $option_stream = '';
        if(is_string($this->data)){
            $tmp = explode(",",$this->data);
            foreach ($tmp as $item){
                if(is_string($item)){
                    $option_stream .= sprintf('<input name=\'data[%s]\' type="radio" value=\'%s\' placeholder=\'%s\' data-value=\'%s\' />'
                        ,$this->name
                        ,$item
                        ,$item
                        ,$this->value
                    );
                }else{
                    $option_stream .= sprintf('<input name=\'data[%s]\' type="radio" value=\'%s\' placeholder=\'%s\' data-value=\'%s\' />'
                        ,$this->name
                        ,$item['value']
                        ,$item['name']
                        ,$this->value
                    );
                }
            }
        }else{
            foreach ($this->data as $item){
                $option_stream .= sprintf('<input name=\'data[%s]\' type="radio" value=\'%s\' placeholder=\'%s\' data-value=\'%s\' />'
                    ,$this->name
                    ,$item['value']
                    ,$item['name']
                    ,$this->value
                );
            }
        }

        if($this->format=="flex"){
            $stream .= sprintf('<div class="row-flex mgb-15 text-ch">
                <div class="col-auto">
                    <span class="label pdl-none">%s%s</span>
                </div>
                <div class="col-auto"><span class="label">:</span></div>
                <div class="col-other">
                    %s
                </div>
            </div>'
                ,$this->is_require?'<span class="pdremr-2">*</span>':''
                ,$this->title
                ,$option_stream
            );
        }else if($this->format=="card"){
            return trim(sprintf('<div class="card mgb-15 text-ch">
                    <div class="card-head"><span class="label pdl-none">%s%s</span></div>
                    <div class="card-body">%s</div>
                    <div class="card-foot"><span class="label pdl-none label-tips">%s</span></div>
                </div>'
                ,$this->is_require?'<span class="pdremr-2">*</span>':''
                ,$this->title
                ,$option_stream
                ,$this->desc
            ));
        }else{
            throw new Error("暂不支持".$this->format."布局方式");
        }
        return $stream;
    }

    //显示个客户端的样子
    public function toCustom($data){
        $stream = "";
        if($this->format=="flex"){
            $stream .= trim(sprintf('<div class="row-flex">
                <div class="col-auto"><span class="label pdl-none">%s：</span></div>
                <div class="col-other"><span class="label pdl-none">%s</span></div>
                </div>'
                ,$this->title
                ,$data
            ));
        }else if($this->format=="card"){
            $labels = "";
            foreach (explode(",",$this->data) as $dataitem){
                if($dataitem==$data){
                    $labels .= sprintf('<span class="label">■%s</span>',$dataitem);
                }else{
                    $labels .= sprintf('<span class="label">□%s</span>',$dataitem);
                }
            }
            $stream .= trim(sprintf('<div class="card mgb-15 text-ch">
                    <div class="card-head"><span class="label pdl-none">%s：</span></div>
                    <div class="card-body">%s</div>
                    <div class="card-foot"></div>
                </div>'
                ,$this->title
                ,$labels
            ));
            //var_dump($stream);exit();
        }else if($this->format=="simple"){
            return $this->toCustomWithSimple($data);
        }else{
            throw new Error("暂不支持".$this->format."布局方式");
        }
        return $stream;
    }

    /**
     * 展示custom的内容
     */
    public function toCustomWithFlex($data = ""){
        $labels = "";
        foreach (explode(",",$this->data) as $dataitem){
            if($dataitem==$this->value){
                $labels .= sprintf('<span class="label">■%s</span>',$dataitem);
            }else{
                $labels .= sprintf('<span class="label">□%s</span>',$dataitem);
            }
        }
        $stream = trim(sprintf('<div class="row-flex">
                <div class="col-other"><span class="label">%s：</span></div>
                <div class="col-auto">%s</div>
                </div>'
            ,$this->title
            ,$labels
        ));
        return $stream;
    }
    public function toCustomWithCard($data = ""){
        $labels = "";
        foreach (explode(",",$this->data) as $dataitem){
            if($dataitem==$this->value){
                $labels .= sprintf('<span class="label">■%s</span>',$dataitem);
            }else{
                $labels .= sprintf('<span class="label">□%s</span>',$dataitem);
            }
        }
        $stream = trim(sprintf('<div class="card card-form-item-radio text-ch">
                    <div class="card-head"><span class="label pdl-none">%s：</span></div>
                    <div class="card-body">%s</div>
                    <div class="card-foot"></div>
                </div>'
            ,$this->title
            ,$labels
        ));
        return $stream;
    }

    public function toCustomWithSimple($data){
        return trim(sprintf('<div class="row-flex">
                <div class="col-auto"><span class="label pdl-none pdr-none">%s：</span></div>
                <div class="col-other"><span class="label pdl-none pdr-none">%s</span></div>
                </div>'
            ,$this->title
            ,$data
        ));
    }

}