<?php
namespace Kuoqi\Kuoqiui\Form\Item;
use Kuoqi\Error;
use Kuoqi\Kuoqiui\Form\ConfigForm;
use Kuoqi\Kuoqiui\Form\ItemForm;

/**
 * 一个选项类的表单的内容
 * Class SeelctItemForm
 * @package Kuoqi\Kuoqiui\Form\Item
 */
class SelectItemForm extends ItemForm {
    protected $config = array();
    /**
     * 一个字段的参数的初始化
     * ItemForm constructor.
     * @param array $opts
     */
    public function __construct($opts = array())
    {
        parent::__construct($opts);
    }

    //显示为视图的文件内容
    public function toView(){
        $option_stream = "";
        if(is_string($this->data)){
            $tmp = explode(",",$this->data);
            foreach ($tmp as $item){
                if(is_string($item)){
                    $option_stream.= sprintf('<option value="%s">%s</option>',$item,$item);
                }else{
                    $option_stream.= sprintf('<option value="%s">%s</option>',$item['value'],$item['name']);
                }
            }
        }else{
            foreach ($this->data as $item){
                $option_stream.= sprintf('<option value="%s">%s</option>',$item['value'],$item['name']);
            }
        }

        $stream = "";
        if($this->format=="flex"){
            $stream .= sprintf('<div %s class="row-flex mgb-15 text-ch">
                <div class="col-auto">
                    <span class="label pdl-none">%s%s</span>
                </div>
                <div class="col-auto"><span class="label">:</span></div>
                <div class="col-other">
                    <select %s class="form-select" name="data[%s]" data-value="%s">%s</select>
                </div>
            </div>'
                ,$this->id?'id="'.$this->id.'"':""
                ,$this->is_require?'<span class="pdremr-2">*</span>':''
                ,$this->title
                ,$this->id?'id="'.$this->id.'-select"':""
                ,$this->name
                ,$this->value
                ,$option_stream
            );

        }else if($this->format=="card"){
            $stream .= trim(sprintf('<div %s class="card mgb-15 text-ch">
                    <div class="card-head"><span class="label pdl-none">%s%s</span></div>
                    <div class="card-body"><select %s class="form-select" name="data[%s]" data-value="%s">%s</select></div>
                    <div class="card-foot"><span class="label pdl-none label-tips">%s</span></div>
                </div>'
                ,$this->id?'id="'.$this->id.'"':""
                ,$this->is_require?'<span class="pdremr-2">*</span>':''
                ,$this->title
                ,$this->id?'id="'.$this->id.'-select"':""
                ,$this->name
                ,$this->value
                ,$option_stream
                ,$this->desc
            ));
        }else{
            throw new Error("暂不支持".$this->format."布局方式");
        }
        return $stream;
    }

    //显示个客户端的样子
    public function toCustom($data){
        $stream = "";
        if($this->format=="flex"){
            $stream .= trim(sprintf('<div class="row-flex">
                <div class="col-auto"><span class="label pdl-none">%s：</span></div>
                <div class="col-other"><span class="label pdl-none">%s</span></div>
                </div>'
                ,$this->title
                ,$data
            ));
        }else if($this->format=="card"){
            $stream .= trim(sprintf('<div class="card mgb-15 text-ch">
                    <div class="card-head"><span class="label pdl-none">%s：</span></div>
                    <div class="card-body"><input readonly class="form-input" value="%s" /></div>
                    <div class="card-foot"></div>
                </div>'
                ,$this->title
                ,$data
            ));
        }else if($this->format=="simple"){
            return $this->toCustomWithSimple($data);
        }else{
            throw new Error("暂不支持".$this->format."布局方式");
        }
        return $stream;
    }

    public function toCustomWithSimple($data){
        return trim(sprintf('<div class="row-flex">
                <div class="col-auto"><span class="label pdl-none pdr-none">%s：</span></div>
                <div class="col-other"><span class="label pdl-none pdr-none">%s</span></div>
                </div>'
            ,$this->title
            ,$data
        ));
    }
}