<?php
namespace Kuoqi\Kuoqiui\Form\Item;
use Kuoqi\Error;
use Kuoqi\Kuoqiui\Form\ItemForm;

/**
 * 多行字符串数据信息
 * Class TextareaItemForm
 * @package Kuoqi\Kuoqiui\Form\Item
 */
class TextareaItemForm extends ItemForm {
    protected $config = array();
    /**
     * 一个字段的参数的初始化
     * ItemForm constructor.
     * @param array $opts
     */
    public function __construct($opts = array())
    {
        parent::__construct($opts);
    }

    //显示为视图的文件内容
    public function toView(){
        if($this->format=="flex"){
            return sprintf('<div class="row-flex mgb-15 text-ch">
                    <div class="col-auto">
                        <span class="label pdl-none">%s%s</span>
                    </div>
                    <div class="col-auto"><span class="label">:</span></div>
                    <div class="col-other">
                        <textarea name=\'data[%s]\' class="form-textarea" placeholder="%s" rows="%s">%s</textarea>
                    </div>
                </div>'
                ,$this->is_require?'<span class="pdremr-2">*</span>':''
                ,$this->title
                ,$this->name
                ,$this->tips
                ,$this->data
                ,$this->value
            );
        }else if($this->format=="card"){
            return trim(sprintf('<div class="card mgb-15 text-ch">
                    <div class="card-head"><span class="label pdl-none">%s%s</span></div>
                    <div class="card-body">
                        <textarea name=\'data[%s]\' class="form-textarea" placeholder="%s" rows="%s">%s</textarea>
                    </div>
                    <div class="card-foot"><span class="label pdl-none label-tips">%s</span></div>
                </div>'
                ,$this->is_require?'<span class="pdremr-2">*</span>':''
                ,$this->title
                ,$this->name
                ,$this->tips
                ,$this->data
                ,$this->value
                ,$this->desc
            ));
        }else{
            throw new Error("暂不支持".$this->format."布局方式");
        }
    }

    //显示个客户端的样子
    public function toCustom($data = ""){
        $stream = "";
        if($this->format=="flex"){
            $stream .= trim(sprintf('<div class="row-flex">
                <div class="col-auto"><span class="label pdl-none">%s：</span></div>
                <div class="col-other"><span class="label pdl-none">%s</span></div>
                </div>'
                ,$this->title
                ,$data
            ));
        }else if($this->format=="card"){
            return trim(sprintf('<div class="card mgb-15 text-ch">
                    <div class="card-head"><span class="label pdl-none">%s%s</span></div>
                    <div class="card-body">
                        <textarea readonly class="form-textarea" rows="%s">%s</textarea>
                    </div>
                    <div class="card-foot"><span class="label pdl-none label-tips">%s</span></div>
                </div>'
                ,$this->is_require?'<span class="pdremr-2">*</span>':''
                ,$this->title
                ,$this->data
                ,$data
                ,$this->desc
            ));
        }else if($this->format=="simple"){
            return $this->toCustomWithSimple($data);
        }else{
            throw new Error("暂不支持".$this->format."布局方式");
        }
        return $stream;
    }

    public function toCustomWithFlex($data = ""){
        $stream = trim(sprintf('<div class="row-flex">
                <div class="col-other"><span class="label">%s：</span></div>
                <div class="col-auto"><span class="label label-underline">%s</span></div>
                </div>'
            ,$this->title
            ,$this->value
        ));
        return $stream;
    }

    //直接单行显示
    public function toCustomWithLine($data = ""){
        $stream = trim(sprintf('<div class="">
                <span class="label pdr-none">%s：</span>
                <span class="label pdl-none label-underline">%s</span>
                </div>'
            ,$this->title
            ,$this->value
        ));
        return $stream;
    }

    public function toCustomWithSimple($data){
        return trim(sprintf('<div class="row-flex">
                <div class="col-auto"><span class="label pdl-none pdr-none">%s：</span></div>
                <div class="col-other"><span class="label pdl-none pdr-none">%s</span></div>
                </div>'
            ,$this->title
            ,$data
        ));
    }



}