<?php
namespace Kuoqi\Kuoqiui\Paginate;

/**
 * 关于一个的控件
 * Class TableHeadOne
 * @package Kuoqi\Kuoqiui
 */
class TableBodyOne extends \Kuoqi\KuoqiException {
    protected $title = '';//关于显示的标识
    protected $name = '';//关于name字段
    protected $func = '';//关于额外处理当前字段的方法
    protected $order = false;//是否开启排序
    protected $value = null;//设置的值的相关信息
    protected $data = array();//自带的数据信息
    protected $width = 0;//设置的值的相关信息
    protected $classname = "";//设置的值的相关信息
    public function __construct($col)
    {
        if(isset($col['title'])){ $this->title = $col['title'];}
        if(isset($col['name'])){ $this->name = $col['name'];}
        if(isset($col['func'])){ $this->func = $col['func'];}
        if(isset($col['order'])){ $this->order = $col['order'];}
        if(isset($col['value'])){ $this->value = $col['value'];}
        if(isset($col['data'])){ $this->data = $col['data'];}
        if(isset($col['width'])){ $this->width = $col['width'];}
        if(isset($col['classname'])){ $this->classname = $col['classname'];}
    }
    public function toString($data){
        $data = array_merge($data,$this->data);
        $stream = "";
        if($this->value){
            $stream = ($this->value)($data);
        }else{
            if(isset($data[$this->name])){
                $stream = $data[$this->name];
            }
        }
        return sprintf('<td class="%s" data-name="'.$this->name.'" width="'.$this->width.'">
                %s
            </td>',
            $this->classname,
            $this->func($stream)
        );
    }

    //这个是处理当前数据的内容
    protected function func($stream){
        switch(strtolower($this->func)){
            case "datetime":return date('Y-m-d H:i:s',$stream);
            case "date":return date('Y-m-d',$stream);
            case "price":return \Kuoqi\Helper::price_encode($stream);
            case "phone":return \Kuoqi\Helper::phone($stream);
            default:return $this->funcDefault($stream);
        }
    }

    protected function funcDefault($stream){
        if($this->func){
            //判定是否为对象方法的模式
            $isclassfunc = explode("::",$this->func);
            if(count($isclassfunc)==2){
                $classname = $isclassfunc[0];
                $funcname = $isclassfunc[1];
                if(class_exists($classname,false) && method_exists($classname,$funcname)){
                    return $classname::$funcname($stream);
                }else{
                    return $stream;
                }
            }else{
                //todo--这个可以继续扩展
                return $stream;
            }
        }else{
            return $stream;
        }
    }
}