<?php
namespace Kuoqi\Kuoqiui\Paginate;
use \Kuoqi\Config;
/**
 * 关于分页的相关信息处理
 * Class TablePager
 * @package Kuoqi\Kuoqiui\Paginate
 */
class TablePager extends \Kuoqi\KuoqiException {
    public $total_count = 0;//总计的数量信息
    public $page_count = 0;//分页的条数信息
    public $page_now = 1;//当前页码信息
    protected $buffer = '';//输出的内容信息
    public $pager;
    public $dconfig;
    public function __construct($config)
    {
        $this->total_count = isset($config['total_count'])?$config['total_count']:$this->total_count;
        $this->page_count = isset($config['page_count'])?$config['page_count']:$this->page_count;
        $this->page_now = isset($config['page_now'])?$config['page_now']:$this->page_now;
    }
    public function toString(){
        $this->validate();
        $this->pageNowBuild();
        $this->creatBianJie();
        $this->ShowStart();
        $this->ShowLast();
        $this->ShowNow();
        $this->ShowNext();
        $this->ShowEnd();
        return '<div class="table-pager-desc">-</div><ul class="table-pager-ul">'.$this->buffer.'</ul>';
    }

    final function validate(){
        $this->dconfig['pageShow'] = $this->pager;
        $this->dconfig['PageMax'] = ceil($this->total_count/$this->page_count);
        $this->dconfig['LineLeft'] = Config::get('DB_PAGE_LLINE');
        $this->dconfig['LineRight'] = Config::get('DB_PAGE_RLINE');
        $this->dconfig['LinePage'] = Config::get('DB_PAGE_LLINE')+Config::get('DB_PAGE_RLINE')+1;
        $this->dconfig['Lang'] = Config::get('DB_PAGE_LANG');
        $this->dconfig['pagekey'] = Config::get('DB_PAGE_VAR');
        $this->dconfig['baseurl'] = Config::get('DB_PAGE_BSURL');
    }
    final function pageNowBuild(){
        if($this->dconfig['pageShow']>=$this->dconfig['PageMax'] && $this->dconfig['PageMax']>1){
            $this->dconfig['pageShow']=$this->dconfig['PageMax'];
        }elseif($this->dconfig['pageShow']<=1){
            $this->dconfig['pageShow']=1;
        }
    }
    final function creatBianJie(){
        $this->dconfig['LineStart'] = 1;
        $this->dconfig['LineEnds'] = $this->dconfig['PageMax'];
        if($this->dconfig['pageShow']-$this->dconfig['LineLeft']>$this->dconfig['LineStart']){
            $this->dconfig['LineStart'] = $this->dconfig['pageShow']-$this->dconfig['LineLeft'];
        }
        if($this->dconfig['pageShow']+$this->dconfig['LineRight']<$this->dconfig['LineEnds']){
            $this->dconfig['LineEnds'] = $this->dconfig['pageShow']+$this->dconfig['LineRight'];
        }
    }
    final function ShowStart(){
        if($this->dconfig['Lang']=='en'){
            $tmp ="First";
        }else{
            $tmp ="&lt;&lt;";
        }
        $this->buffer .="<li class='table-kuoqiui-pager-li'><a data-page='1'>{$tmp}</a></li>";
    }
    final function ShowLast(){
        if($this->dconfig['LinePage']-1>1){
            if($this->dconfig['PageMax']<$this->dconfig['LinePage']){
                $last=$this->dconfig['PageMax'];
            }else{
                $last=$this->dconfig['LinePage']-1;
            }
        }else{$last=1;}
        if($this->dconfig['Lang']=='en'){$tmp ="Prev";}else{$tmp ="&lt;";}
        $this->buffer .= "<li class='table-kuoqiui-pager-li'><a data-page='".$last."'>{$tmp}</a></li>";
    }
    final function ShowNow(){
        for($i=$this->dconfig['LineStart'];$i<=$this->dconfig['LineEnds'];$i++)
        {
            if($this->dconfig['pageShow']==$i)
            {
                $this->buffer .= "<li class='table-kuoqiui-pager-li active'><a data-page='".$i."'>".$i."</a></li>";
            }
            else
            {
                $this->buffer .= "<li class='table-kuoqiui-pager-li'><a data-page='".$i."'>".$i."</a></li>";
            }
        }
    }
    final function ShowNext(){
        if($this->dconfig['LinePage']+1<$this->dconfig['PageMax']){$next=$this->dconfig['LinePage']+1;}else{$next=$this->dconfig['PageMax'];}
        if($this->dconfig['Lang']=='en'){$tmp ="Next";}else{$tmp ="&gt;";}
        $this->buffer .= "<li class='table-kuoqiui-pager-li'><a   data-page='".$next."'>{$tmp}</a></li>";
    }
    final function ShowEnd(){
        $this->buffer .= "<li class='table-kuoqiui-pager-li'><a data-page=".$this->dconfig['PageMax'].">";
        if($this->dconfig['Lang']=='en'){
            $this->buffer .="Last";
        }else{
            $this->buffer .="&gt;&gt;";
        }
        $this->buffer .="</a></li>";
    }
    final function url($baseurl,$params){
        $url = new \Kuoqi\Url();
        $url->setLink($baseurl);
        $url->addQuery(\Kuoqi\Params::$INPUT_GETS);
        $url->addQuery($params);//增加属性信息
        return $url->tolink();
    }
}