<?php
namespace Kuoqi\Kuoqiui\Template;
use Kuoqi\Input;

/**
 * 菜单系列的模块
 * Class Menu
 * @package Kuoqi\Kuoqiui
 */
class Menu{
    protected $lister = array();//列表数据
    protected $item_custom = null;//是否自定义item解析方法
    public $id_code = 'id';//唯一标识的字段名
    public $turn_id = 0;//使用的PID的值
    public $turn_code = 'pid';//使用轮询的字段
    public $text_code = 'name';//字段的名称
    public $icon_code = 'icon';//有些需要icon的时候使用icon的class
    public $stream = '';
    //解析位数枝
    public function analysisMenuTreestring($pid = 0){
        if(!is_array($this->lister)){ return '';}
        foreach ($this->lister as $v){
            if($v[$this->turn_code]==$pid){
                $this->stream .= '<li>';
                $tmp = ($this->item_custom)($v);
                if(is_array($tmp)){
                    $break = Input::checkParam("break",false,$tmp);
                    $stream = Input::checkParam("stream","",$tmp);
                    if($break){
                        //如果判定有break的枝丫，则直接隐藏相关内容
                        $this->stream .= $stream;
                        $this->stream .= '</li>';
                        continue;
                    }else{
                        $this->stream .= $stream;
                    }
                }else{
                    $this->stream .= $tmp;
                }
                foreach ($this->lister as $sv){
                    if($sv[$this->turn_code]==$v[$this->id_code]){
                        $this->stream .= "<ul>";
                        $this->analysisMenuTreestring($v[$this->id_code]);
                        $this->stream .= "</ul>";
                        break;
                    }
                }
                $this->stream .= '</li>';
            }
        }
    }

    /**
     *
     * analysisCheckboxTreestring 2024-11-04
     * @param int $pid
     * @param array $checkids
     */
    public function analysisCheckboxTreestring($pid = 0,$checkids = array()){
        foreach ($this->lister as $v){
            if($v[$this->turn_code]==$pid){
                $this->stream .= '<div class="tree-branch">';
                if(in_array($v[$this->id_code],$checkids)){
                    $this->stream .= '<div class="branch-body"><label class="branch-content"><input data-init="true" checked="checked" type="checkbox" name="ids[]" value="'.$v[$this->id_code].'" /><span>'.$v[$this->text_code].'</span></label></div>';
                }else{
                    $this->stream .= '<div class="branch-body"><label class="branch-content"><input data-init="true" type="checkbox" name="ids[]" value="'.$v[$this->id_code].'" /><span>'.$v[$this->text_code].'</span></label></div>';
                }
                foreach ($this->lister as $sv){
                    if($sv[$this->turn_code]==$v[$this->id_code]){
                        $this->analysisCheckboxTreestring($v[$this->id_code],$checkids);
                        break;
                    }
                }
                $this->stream .= '</div>';
            }
        }
    }
    /**
     * 自定义的树形菜单
     * @param $data
     * @param $func
     * @return null
     */
    static public function treeMenuCustom($data,$func,$pid = 0){
        $menu = new self();
        if(is_object($func)){
            $menu->item_custom = $func;
        }
        $menu->lister = $data;
        $menu->analysisMenuTreestring($pid);//解析为树子的形式
        return $menu->stream;
    }

    //treeCheckbox
    static public function treeCheckbox($data,$checkids){
        $menu = new self();
        $menu->lister = $data;
        $menu->analysisCheckboxTreestring(0,$checkids);//解析为树子的形式
        return $menu->stream;
    }
}