<?php
namespace Kuoqi\Kuoqiui\Totaler;
use Kuoqi\Error;
use Kuoqi\Kuoqiui\Totaler;

/**
 * 线性统计坐标图相关信息
 * Class LineDateToal
 * @package Kuoqi\Kuoqiui
 */
class LineDateTotal extends Totaler {
    protected $_x_axis = '';
    protected $_time_format = '';
    protected $_min_xaxis = null;
    protected $_max_xaxis = null;
    /**
     * 设置时间刻度的值的相关信息
     * @param $xAxis
     */
    public function setTimecols($xAxis){
        $this->_x_axis = $xAxis;
    }

    /**
     * 设置X的最小值
     * @param $code
     */
    public function setXaxisMin($code){ $this->_min_xaxis = floatval($code);}

    /**
     * 设置X的最大值
     * @param $code
     */
    public function setXaxisMax($code){ $this->_max_xaxis = floatval($code);}

    /**
     * 设置X的格式信息
     * @param $timeFormat
     */
    public function setTimeformat($timeFormat){
        $this->_time_format = $timeFormat;
    }
    //设置冲刷数据
    public function flush(){
        //获取X字段的最小值
        if(!$this->_min_xaxis){
            $this->_min_xaxis = floatval($this->getFieldMinData($this->_x_axis,time()));
        }
        if(!$this->_max_xaxis){
            //获取X字段的最大值
            $this->_max_xaxis = floatval($this->getFieldMaxData($this->_x_axis,time()));
        }

        //根据极限值设置X的相关数据
        switch ($this->_time_format){
            case 'm':$this->flushByMonth();break;
            case 'h':$this->flushByHours();break;
            default:$this->flushByDay();
        }
    }
    protected function flushByHours(){
        $min = $this->_min_xaxis;
        $max = $this->_max_xaxis;
        $this->buffer = array();
        while ($min<$max){
            $start = strtotime(date('Y-m-d H:00:00',$min));//等于
            $end = $start+3600;//小鱼
            $min = $end;
            $this->buffer[] = array('s'=>$start,'e'=>$end,'date'=>date('Y-m-d H',$start),'data'=>0);
        }
        foreach ($this->buffer as $k=>$time){
            foreach ($this->dataer as $item){
                if($item[$this->_x_axis]>=$time['s'] && $item[$this->_x_axis]<$time['e']){
                    $this->buffer[$k]['data']++;
                }
            }
        }
    }
    //根据区间设置x轴的相关数据信息,根据每条的时间
    protected function flushByDay(){
        $min = $this->_min_xaxis;
        $max = $this->_max_xaxis;
        $this->buffer = array();
        while ($min<$max){
            $start = strtotime(date('Y-m-d 00:00:00',$min));//等于
            $end = $start+86400;//小鱼
            $min = $end;
            $this->buffer[] = array('s'=>$start,'e'=>$end,'date'=>date('Y-m-d',$start),'data'=>0);
        }
        foreach ($this->buffer as $k=>$time){
            foreach ($this->dataer as $item){
                if(($item[$this->_x_axis]>=$time['s']) && ($item[$this->_x_axis]<$time['e'])){
                    $this->buffer[$k]['data']++;
                }
            }
        }
    }

    /**
     * 区间设置为个月的相关提示
     */
    protected function flushByMonth(){
        $min = $this->_min_xaxis;
        $max = $this->_max_xaxis;
        $this->buffer = array();
        while ($min<$max){
            $start = strtotime(date('Y-m-01 00:00:00',$min));//等于
            $end = strtotime(date('Y-m-01 00:00:00',$start + 3000000));//小鱼
            $min = $end;
            $this->buffer[] = array('s'=>$start,'e'=>$end,'date'=>date('Y-m',$start),'data'=>0);
        }
        foreach ($this->buffer as $k=>$time){
            foreach ($this->dataer as $item){
                if($item[$this->_x_axis]>=$time['s'] && $item[$this->_x_axis]<$time['e']){
                    $this->buffer[$k]['data']++;
                }
            }
        }
    }

    /**
     * 设置返回buffer的内容信息
     * @return array
     */
    public function getBuffer(){
        $list = array('data'=>array(),'date'=>array());
        foreach ($this->buffer as $k=>$v){
            $list['data'][] = $v['data'];
            $list['date'][] = $v['date'];
        }
        return $list;
    }
}