<?php
namespace Kuoqi\Model\Data;
//模型的属性对象，每一个属性都有单独的一个对象
use Kuoqi\Error;
use Kuoqi\FileDriver;

class FieldDataModel{
    protected $file = "";//字段是属于哪个文件的
    protected $name = "";//字段的名称
    protected $value = "";//字段的最后一个的值
    protected $config = array();//字段的配置的详细数据

    /**
     * 初始化
     * FieldDataModel constructor.
     * @param $file
     * @param $name
     * @throws Error
     */
    public function __construct($file,$name)
    {
        $this->file = $file;
        if(is_array($name)){
            //如果是一个数组，则为当前数组的完成内容
            $this->config = $name;
            if(!$name["name"]){
                throw new Error("初始化为数组的情况下，数组中必须包含键名为[name]的字符串内容");
            }
            $this->name = $name["name"];
        }else{
            //如果是一个字符串，则为当前的字段的名称
            $this->name = $name;
        }
    }

    /**
     * 创建字段的内容
     * create 2024-07-23
     */
    public function create(){
        //打开文件，并写入字段的信息
        $config = new FileDriver\ConfigFileDriver($this->file);
        $this->config = array("name"=>$this->name,'sort'=>$config->getCount());
        $config->set($this->name, $this->config);
        $config->save();
    }

    /**
     * 获取名字的内容
     * getName 2024-07-23
     * @return string
     */
    public function getName(){
        return $this->name;
    }

    /**
     * 设置当前字段的临时值
     * setValue 2024-07-23
     * @param $val
     */
    public function setValue($val){
        $this->value = $val;
    }

    /**
     * 获取当前字段的临时值
     * getValue 2024-07-23
     * @return string
     */
    public function getValue(){
        return str_replace(" ","\s",$this->value);
    }

    //验证一个值是否符合当前字段的规则
    public function valiValue(){
        return true;
    }
}