<?php
namespace Kuoqi\Model\Model;

/**
 * 数据验证模块的相关信息开发
 * Class FilterModel
 * @package Kuoqi\Model\Model
 */
class FilterModel{

    static public function Filter($code,$data){
        switch(strtolower($code)){
            case 'array':return self::FilterArray($data);//这个包含必填与自动处理为数组
            case 'require':return self::FilterRequire($data);
            case 'int':return self::FilterIntval($data);
            case 'intval':return self::FilterIntval($data);
            case 'password':return self::FilterPassword($data);
            case 'price':return self::FilterPrice($data);
            case 'strtotime':return self::FilterStrtotime($data);
            case 'timestamp':return self::FilterStrtotime($data);
            default:return $data;
        }
    }

    /**
     * 是否维数组，且必填
     * FilterArray 2024-08-22
     * @param $stream
     * @return null|string
     */
    static public function FilterArray($stream){
        if(count($stream)){
            $stream = implode(",",str_replace(",","&sbquo;",$stream));
            return $stream;
        }else{
            return null;
        }
    }

    //判定是否为必填
    static public function FilterRequire($stream){
        if(strlen($stream)){
            return $stream;
        }else{
            return null;
        }
    }
    //判定为intval
    static public function FilterIntval($stream){
        return intval($stream);
    }

    //密码
    static public function FilterPassword($stream){
        return \Kuoqi\Format::getPassword($stream);
    }

    //将金额转换为分
    static public function FilterPrice($stream){
        return intval(floatval($stream) * 100);
    }
    //时间转时间戳
    static public function FilterStrtotime($stream){
        return intval(strtotime($stream));
    }
}