<?php
namespace Kuoqi\Process;
/**
 * 独立的进程管理对象，一个新增进程需要一个管理，不需要任何的下级继承
 * Class ItemProcess
 * @package Kuoqi\Process
 */
class ItemProcess extends \Kuoqi\Process {
    private $file = '';//关联的文件
    protected $process_id = 0;//当前进程的ID
    protected $_id = '';//唯一识别ID
    protected $opts = array();
    public function __construct($file,$opts = array())
    {
        $this->file = $file;
        $this->opts = $opts;
        $this->_id = md5($this->file.'_tmp'.rand(1000,9999));
        parent::__construct();
    }
    //获取唯一标识
    //获取当前绑定进程ID
    public function getProcessid(){
        return $this->process_id;
    }
    //获取文件路径
    public function getComm(){
        $comm = $this->file;
        foreach ($this->opts as $k=>$v){
            $comm .= sprintf(" -%s %s",$k,$v);
        }
        return $comm;
    }
    //获取唯一识别ID
    public function getID(){
        return $this->_id;
    }
    //获取基础的信息
    public function getInfo(){
        return array(
            'pid'=>$this->process_id,
            'id'=>$this->_id,
            'file'=>$this->file,
            'opts'=>$this->opts,
        );
    }
    //关闭进程信息
    public function cancelProcess(){
        if($this->process_id){
            //ID存在，判定是否存活
            $comm = sprintf('taskkill /pid %s /f',$this->process_id);
            $rs = exec($comm);
            if($rs){
                \Kuoqi::warn(sprintf("进程[%s]结束,PID=%s,ID=%s",$this->getComm(),$this->process_id,$this->_id));
                return 0;
            }
        }
    }

    //检测进程是否存活
    //如果非重置则返回数字0，如果返回重置信息，则返回非数字0，如果守护失败则返回false
    public function guardProcess(){
        if($this->process_id){
            //ID存在，判定是否存活
            $comm = sprintf('tasklist | findstr %s',$this->process_id);
            $rs = exec($comm);
            if($rs){
                //todo -- 进程正常则不做任何处理
                //\Kuoqi::warn(sprintf("进程[%s]正常,PID=%s,ID=%s",$this->getComm(),$this->process_id,$this->_id));
                return 0;
            }else{
                //进程已经不存在了，尝试重新启动
                $com = new ComProcess();
                \Kuoqi::warn(sprintf("进程[%s]异常，重启......",$this->getComm()),false);
                $this->process_id = $com->start($this->getComm(),$this->opts);
                \Kuoqi::warn(sprintf("成功,PID=%s,ID=%s",$this->process_id,$this->_id));
                return $this->process_id;
            }
        }else{
            //ID不存在，直接判定进程不存活
            $com = new ComProcess();
            \Kuoqi::warn(sprintf("进程[%s]启动......",$this->getComm()),false);
            $this->process_id = $com->start($this->getComm());
            \Kuoqi::warn(sprintf("成功,PID=%s,ID=%s",$this->process_id,$this->_id));
            return $this->process_id;
        }
    }
}