<?php
namespace Kuoqi\Socket;
use Kuoqi\Error;

/**
 * 一个简单的socket client 客户端，客户端基础脚本,是基于socket的全双通的脚本信息
 * Class Client
 * @package Kuoqi\Socket
 */
class Client extends  Behavior {
    public function __construct($server_address,$server_port,$opts = array())
    {
        parent::__construct($server_address,$server_port,$opts);
    }
    protected function init(){
        $this->initCreate()&&$this->initConnect();
    }

    public function start(){
        $this->init();
        if($this->isValied()){
            $this->handshake(); //这里进行握手协议
        }
    }

    //结束一个socket
    public function end(){
        socket_shutdown($this->master);
        socket_close($this->master);
    }

    /**
     * 发送一个数据包
     * @param $msg 发送的数据信息
     * @return int 返回的发送数据的长度
     */
    public function postMessage($msg){
        //socket_set_option($this->master, SOL_SOCKET, TCP_NODELAY, 1);
        if(is_array($msg)){
            $msg = json_encode($msg);
        }
        $msg = \Kuoqi\Secret::datapass_encode($msg,$this->mode);
        if(socket_write($this->master,$msg,strlen($msg))){
            //usleep(100);
        }else{
            $this->debug("发送信息失败:".'[length:'.strlen($msg).']'.substr($msg,0,36).'......');
        }
    }

    //监听一个收取消息的监听
    public function onMessage($callfunc,$options = array()){
        if(false===$stream = socket_read($this->master,$this->package_size)){
            return $this->debug("接收消息失败");
        }
        $arr = \Kuoqi\Secret::datapass_decode($stream,$this->mode);
        if(!$arr){
            return $this->debug("被舍弃字符串");
        }
        $stream = $arr['stream'];
        while($arr['len']>strlen($stream)){
            $stream .= socket_read($this->master,$this->package_size);;
        }

        if(is_callable($callfunc)){
            return call_user_func($callfunc,$stream,$this,$options);
        }else{
            $this->debug("没有返回的执行方法");
            return ;
        }
    }

    //自定义握手协议的内容
    protected function handshake(){
        $this->postMessage(sprintf("kuoqi://handshake?token=%s",$this->token));
    }
}