<?php
namespace Kuoqi\Socket;
use Kuoqi\Error;

/**
 * 一个HTTP客户端的链接
 * Class Client
 * @package Kuoqi\Socket
 */
class HttpClient extends  Behavior {
    public function __construct($server_address,$server_port,$opts = array())
    {
        parent::__construct($server_address,$server_port,$opts);
    }
    protected function init(){
        // Create a new socket
        $sock = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);

// An example list of IP addresses owned by the computer
        $sourceips['kevin']    = '127.0.0.1';
        $sourceips['madcoder'] = '127.0.0.2';

// Bind the source address
        socket_bind($sock, $sourceips['madcoder']);

// Connect to destination address
        socket_connect($sock, '127.0.0.1', 80);

// Write
        $request = 'GET / HTTP/1.1' . "\r\n" .
            'Host: example.com' . "\r\n\r\n";
        socket_write($sock, $request);

// Close
        socket_close($sock);
    }

    public function start(){
        $this->init();
        if(!$this->isValied()){
            throw new Error($this->getError());
        }
        //这里进行握手协议
        $this->handshake();
    }

    //结束一个socket
    public function end(){
        //socket_close($this->master);
    }

    /**
     * 发送一个数据包
     * @param $msg 发送的数据信息
     * @return int 返回的发送数据的长度
     */
    public function postMessage($msg,$context = true){
        //$msg = \Kuoqi\Secret::datapass_encode($msg);
        //int socket_send( resource $socket, string $buf, int $len, int $flags)
        if(is_array($msg)){
            $msg = json_encode($msg);
        }
        if($context){
            //$msg = $msg.hex2bin('04');
        }
        $this->debug("发送信息:".'[length:'.strlen($msg).']'.substr($msg,0,36).'......');
        if(!socket_write ($this->master,$msg,strlen($msg))){
            $this->debug("发送信息失败:".'[length:'.strlen($msg).']'.substr($msg,0,36).'......');
        }
        flush();
    }

    //监听一个收取消息的监听
    public function onMessage(){
        socket_recv($this->master, $buf, 2048, 0);
    }
    //自定义握手协议的内容
    protected function handshake(){
        $this->postMessage(sprintf("kuoqi://handshake?token=%s",$this->token),false);
    }
}