<?php
namespace Kuoqi\Socket;

/**
 * Class WebSocket
 * @package Kuoqi\Worker
 */
class WebSocket extends  \Kuoqi\Socket\Socket {
    //新客户端加入的时候进行一个写入
    function doConnect($socket){
        $bytes = @socket_recv($socket,$buffer,2048,0);
        if($bytes==0){
            $this->debug("this user no send any authdata");
        }else{
            $header = $this->getHeaders($buffer);
            list($resource, $host, $origin, $key) = $header;
            $reskey = $this->calcKey($key);
            $upgrade
                = "HTTP/1.1 101 Switching Protocol\r\n" .
                "token:XXX\r\n".
                "Upgrade: websocket\r\n" .
                "Connection: Upgrade\r\n" .
                "Sec-WebSocket-Accept: " . $reskey . "\r\n\r\n";
            array_push($this->sockets, $socket);
            socket_write($socket, $upgrade, strlen($upgrade));
            if(is_callable($this->event['login'])){
                call_user_func($this->event['login'],$socket,$this);
            }else{
                $this->debug("客户端 ".$socket . "登录成功");
            }
        }
    }
    /**
     * 基于websocket version 13
     * @param $key
     * @return string
     * User kuoqi
     * Datetime 2022/3/24 9:31
     * Remark
     */
    function calcKey($key){
        //基于websocket version 13
        $accept = base64_encode(sha1($key . '258EAFA5-E914-47DA-95CA-C5AB0DC85B11', true));
        return $accept;
    }
    function getHeaders($req){
    $r = $h = $o = $key = null;
    if (preg_match("/GET (.*) HTTP/"              ,$req,$match)) { $r = $match[1]; }
    if (preg_match("/Host: (.*)\r\n/"             ,$req,$match)) { $h = $match[1]; }
    if (preg_match("/Origin: (.*)\r\n/"           ,$req,$match)) { $o = $match[1]; }
    if (preg_match("/Sec-WebSocket-Key: (.*)\r\n/",$req,$match)) { $key = $match[1]; }
    return array($r, $h, $o, $key);
}

    public function postMessage($client,$msg){
        if(is_array($msg)){
            $msg = json_encode($msg);
        }
        $msg = \Kuoqi\Secret::datapass_encode($msg,130);
        if(socket_write($client, $msg, strlen($msg))){
            //usleep(100);
            return true;
        }else{
            $this->debug(sprintf("发送到%s失败:%s",$client,iconv('GBK','UTF-8',socket_strerror(socket_last_error()))));
            return false;
        }
    }
}