<?php
namespace Kuoqi\Worker;
class Httpd extends Behavior {
    static $server = null;//绑定的当前服务的对象信息
    /**
     * Http constructor.
     * @param $host 地址
     * @param $port 端口
     * @param $_root 网站根目录
     */
    public function __construct(){

        //接管异常处理的相关流程
        //接管三大件流程信息
        $this->server_addr = \Kuoqi\Config::get('HTTPD_ADDR');
        $this->server_port = \Kuoqi\Config::get('HTTPD_PORT');
        $this->backlog  = \Kuoqi\Config::get('HTTPD_BACKLOG');
        self::$server = $this;
    }


    /**
     * 启动服务
     */
    public function start()
    {
        if(!$this->CreateNodeCommunication()){ return false;}
        socket_set_block($this->node);//设置阻塞模式
        if(!$this->CreateNodeBind()){ return false;}
        if(!$this->CreateNodeListen()){ return false;}
        return true;
    }
    //监听的执行内容
    public function listen()
    {
        //接收客户端请求
        if(($msgsocket=socket_accept($this->node))!==false){
            //将这个转换为请求的对象，然后在请求的对象里面去解析为常用的数据信息
            try{
                echo 'request ok'.PHP_EOL;
                $request = new Httpd\Request(socket_read($msgsocket,9024));
                $response = new Httpd\Response($request);
                $this->log("请求：".date('Y-m-d H:i:s').' with '.$request->file .' type: '. $request->type);
                $response->httpd = $this;
                $content = $response->responseText();
                socket_write($msgsocket,$content,strlen($content));
                socket_close($msgsocket);

            }catch (\Kuoqi\Error $err){
                echo 'request error'.PHP_EOL;
                $err->quit_debug();
                $content = ob_get_clean();
                $content = $this->GetHeaders('200','ok',$content,"text/html;charset=utf-8");
                socket_write($msgsocket,$content,strlen($content));
                socket_close($msgsocket);

            }
        }
    }

    /**
     * 组装消息头信息模板
     * @param $code 状态码
     * @param $status 状态名称
     * @param string $content 发送的文本内容
     * @param string $content_type 发送的内容类型
     * @return string
     */
    public function GetHeaders($code,$status,$content="",$content_type="text/html;charset=utf-8"){
        $header='';
        $header.="HTTP/1.1 {$code} {$status}\r\n";
        $header.="Date:".gmdate('D,dMYH:i:sT')."\r\n";
        $header.="Content-Type:{$content_type}\r\n";
        $header.="Content-Length:".strlen($content)."\r\n\r\n";//必须2个\r\n表示头部信息结束
        $header.=$content;
        return $header;
    }
}