<?php
namespace Kuoqi\Worker\Httpd;
/**
 * 对于获取的到请求头的数据的一个解析，解析完成之后返回对象信息
 * Class Request
 * @package Kuoqi\Worker
 */
class Request extends \Kuoqi\KuoqiException {
    public $request = '/index.html';//请求地址
    public $file = '';//请求的路径信息，当前暂时已file使用
    public $get_params =array();//请求附带的get参数信息
    public $mime = '';//可接受的文件mime类型
    public $type = 'other';//资源类型
    public $path = '/';//使用的路由
    public $query = '';//使用参数信息
    public $is_file = false;//判定是否是一个文件
    public $is_ext = '';//判定是否有文件的结尾，如果有结尾的话，使用文件结尾,直接判定为文件并返回
    public $_mime_rouces = array(
        'text/html'=>'html',
        'text/css'=>'css',
        'image/*'=>'source',
        '*/*'=>'other',
    );

    public function __construct($buffer,$options = array())
    {
        if(preg_match("/\/(.*)HTTP\/1\.1/",$buffer,$matchs)){
            $this->request = trim($matchs[1]);
            $urlarr = parse_url($this->request);
            //判定是否为已知文件，如果为文件的话，就展示文件，不是文件的话，就按照系统的要求去走
            if(isset($urlarr['path'])&&$urlarr['path']){
                $this->path = $urlarr['path'];
                $fileDriver = new \Kuoqi\FileDriver('{@HOME}/'.$urlarr['path']);
                $fileDriver->exist()&&($this->is_file=true);
                if($fileDriver->getExt()){
                    //这里是有文件结尾的，使用文件结尾
                    $this->is_ext = $fileDriver->getExt();
                    //判定如果文件，结尾为php的情况，需要排除
                    if($this->is_ext=='.php'){
                        $this->is_ext = '';//直接重置为没有文件结尾，使用路由的方式进行
                    }
                }
            }
            if(isset($urlarr['query'])){
                $this->query = $urlarr['query'];
            }
        }
        if(preg_match("/Accept:(.*?)\n/",$buffer,$matchss)){
            $stream = $matchss[1];
            $mimes = explode(',',$stream);
            foreach ($mimes as $v){
                $this->mime = trim($v);
                if(isset($this->_mime_rouces[$this->mime])){
                    $this->type = $this->_mime_rouces[$this->mime];
                    break;
                }
            }
        }
    }

}